(*
Copyright (C) 1999 Grischa Brockhaus <skullsoft@grischa.de>
modified      1999 Andre Grueneberg <andre@grueneberg.de>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)

{$O+,F+}

Unit MTask;
(*
 --------------------------------
   MultiTasker - Unit.
   Erkennen des Betriebssystems,
   TimeSlicing
   Zusammengestellt von G.Brockhaus
   Version 1 : 02.12.93
   Version 2 : 20.12.93
-----------------------------------
*)

INTERFACE
{$IfDef VirtualPascal}
procedure MTDelay( w : word );  { erweitertes delay, fr DV }
Function  MTReadKey : Char;     { ReadKey mit TimeSlice }
PROCEDURE MTSlice;              { Gives up remainder of clock cycle under}

IMPLEMENTATION
Uses Crt;
procedure MTDelay( w : word );  { erweitertes delay, fr DV }
begin
     Delay(w);
end;
Function  MTReadKey : Char;     { ReadKey mit TimeSlice }
begin
     MTReadKey := ReadKey;
end;
PROCEDURE MTSlice;
begin
end;

{$Else}
Const  MT_DOS    = 0;
       MT_DV     = 1;
       MT_OS2    = 2;
       MT_WIN    = 3;
       MT_Max    = 3;
       MT_WasInited : Boolean =False;

Const
       MTKindStr    : Array[0..MT_Max] of String[8] =
                      ('DOS','DESQview','OS/2','Windows');
       DOSKindStr   : Array[0..4] of String[5] =
                      ('MSDOS','DRDOS','NvDOS','DOS +','PalmD');
       MTKind       : Byte    = MT_DOS;
       MTLoaded     : Boolean = False;  (* Tasker gefunden ? *)
       MTVersion    : Word    = $0000;  (* Welche Version ?  *)
       MTVersionStr : String[8] = '';   (* Welche Version ?  *)
       MTWindow     : Word    = $0000;  (* Nur DV: akt. Fenster *)
       Is4DOS       : Boolean = False;
       Vers4DOS     : Word    = $0000;
       VersStr4DOS  : String  = '';

var
   MT_VSEG      : word ;
   MT_VMODE     : Pointer;
   MT_VWIDTH    : byte ;
   MT_VROWS     : byte ;
   MT_VOFS      : word ;

var MT_IdleProc  : Procedure;  { Die wird immer im Idle aufgerufen }

Procedure MT_Install(Kind:Word);{ Initialisierung der Proceduren }
PROCEDURE MTSlice;              { Gives up remainder of clock cycle under
                                  dos, dv, windows, os/2 }
procedure MTDelay( w : word );  { erweitertes delay, fr DV }
Function  MTReadKey : Char;     { ReadKey mit TimeSlice }
procedure MTVideoBuffer ;       { Video Puffer auslesen }
procedure MTStartCritical;      { Task-Switching aus }
procedure MTEndCritical;        { Task-Switching an }
function  DVWinNr: byte ;       { Fenster-Nummer von DV ? }
function  DosKind : Byte;

IMPLEMENTATION
uses {$IFDEF DPMI}
     MinDPMI,
     {$ENDIF}
     dos,crt, timer;
{ ------------------------------------------------------------------------ }
Function DV_GetVersion: word; assembler;
 { update MTLoaded and get version # }
asm
  PUSH   BX
  PUSH   CX
  PUSH   DX
  MOV    CX,'DE'          { CX+DX to 'DESQ' (invalid date) }
  MOV    DX,'SQ'
  MOV    AX,02B01H        { Dos' set date funct. }
  INT    21H              { call dos }
  CMP    AL,0FFH          { Was it invalid? }
  JE     @No_dv           { yep, no dv }
  MOV    AX,BX            { AH=major AL=minor }
  MOV    MTLoaded,1       { Set MTLoaded flag }
  JMP    @DvGv_x          { other routines }
@No_dv:
  XOR    AX,AX              { Return 0 or no DV }
@DvGv_x:
  POP    DX
  POP    CX
  POP    BX
end; { DV_GetVersion }

{ ------------------------------------------------------------------------ }
Procedure CheckWin;
var
  {$IFDEF DPMI}
  regs : TRealModeRegs;
  {$ELSE}
  regs : registers;
  {$ENDIF}
begin
  fillchar(regs, sizeof(regs), 0);
  regs.ax := $1600;
  {$IFDEF DPMI}
  ClearRegs(Regs);
  RealModeInt($2F,Regs);
  {$ELSE}
  Intr($2F,regs);
  {$ENDIF}
  case regs.al of
    $0,$80 : ;
    $1,$ff : begin
               MTLoaded := True;
               MTVersion := $200;
             end;
  else begin
    MTLoaded := True;
    MTVersion:= regs.ax;
    MtVersion:=Swap(MtVersion);
  end;
 end;
end;
{ ------------------------------------------------------------------------ }
Procedure CheckOS2;Assembler;
asm
  mov ah, 30h    { AH = 30h }
  int 21h  { dos version }
  mov BX,AX
  mov al,bh { Swappen }
  mov ah,bl
  mov MTVersion,ax
  cmp ah, 14h
  jae @IBMOS2 { Jump if >= to 20 }
  cmp ah, 0Ah
  jae @IBMOS1 { Jump if >= to 10 }
  jmp @Finish { Nothing found, go to the end }

@IBMOS1:      { OS/1.x }
  mov MTLoaded, 1
  mov MTKind, MT_OS2  { Set OS Value }
  mov ah,1         { Richtige MainVers. (nicht 20 sondern 2) }
  mov MTVersion,ax
  jmp @Finish

@IBMOS2:      { OS/2.x }
  mov MTLoaded, 1
  mov MTKind, MT_OS2  { Set OS Value }
  mov ah,2         { Richtige MainVers. (nicht 20 sondern 2) }
  mov MTVersion,ax
  jmp @Finish

@FINISH:
end; { CheckOS2 }
{ ------------------------------------------------------------------------ }
{$IFDEF DPMI}
Procedure Check4Dos;
var Reg : TRealModeRegs;
begin
     ClearRegs(Reg);
     Reg.Ax := $D44D;
     Reg.Bx := $0000;
     RealModeInt($2F,Reg);
     is4DOS := Reg.AX = $44DD;
     Vers4DOS := Reg.BX;
end;
{$ELSE}
Procedure Check4Dos;Assembler;
{ Aus dem 4DOS Manual }
asm
  mov ax, $D44D  { AH = 30h }
  mov bx, $0000
  int 2Fh
  cmp AX, $44DD
  jne @finish
  mov Vers4DOS,BX
  mov Is4Dos,01
@finish:
end;
{$ENDIF}

{ ------------------------------------------------------------------------ }
Procedure MTInitVStr;
{ Macht aus der Version einen String }
var h1,h2 : String[10];
begin
     Str(Hi(MTVersion),h1);
     Str(Lo(MTVersion),h2);
     MTVersionStr:=H1+'.'+H2;
     If (MTKind=MT_OS2) and (MTVersionStr='2.30') then MTVersionStr:='WARP';
end;
{ ------------------------------------------------------------------------ }
Procedure MTInit;
begin
     { Test auf OS/2 }
     CheckOS2;
     If MTLoaded then begin
        MTKind:=MT_OS2;
        Exit;
     end;
     { Test auf DV }
     MTVersion:= DV_GetVersion;
     If MTLoaded then begin
        Crt.DirectVideo:=False;
        MTKind:=MT_DV;
        MTWindow:=DvWinNr;
        Exit;
     end;
     { Test auf Windows }
     CheckWin;
     If MTLoaded then begin
        MTKind:=MT_WIN;
        Exit;
     end;
     CheckOS2;
end;
{ ------------------------------------------------------------------------ }
PROCEDURE MTSlice; Assembler; {Gives up remainder of clock cycle
                                 under dos, windows, os/2, dv, ddos }
  asm
    CMP MTKind,MT_DOS   { Compare to DOS }
    JE @MSDOS           { Jump if = }
    CMP MTKind,MT_DV    { Compare to Desqview }
    JE @DESQVIEW        { Jump if = }
    CMP MTKind, MT_WIN  { Compare to Windows }
    JE @WINOS2          { Jump if = }
    CMP MTKind, MT_OS2  { Compart OS/2 }
    JE @WINOS2          { Jump if = }
    JMP @NONE           { None found, Jump to End }

 @DESQVIEW:
    MOV ax,1000h { AX = 1000h }
    INT 15h      { Call Interupt 15h }
    JMP @NONE    { Jump to the end }

 @WINOS2:
    MOV AX, 1680h       { AX = 1680h }
    INT 2Fh             { Call Interupt 2Fh for Win-OS/2 TimeSlice }
    CMP MTKind, MT_OS2  { Bei OS/2 noch den DOS Idle mitnehmen }
    JNE @NONE           { Jump if = }

 @MSDOS:
    INT 28h   { Interupt 28h }

 @NONE:
    CALL MT_IdleProc

end; {MTSlice}

{ ------------------------------------------------------------------------ }
procedure MTVideoBuffer ;
begin

  MT_VMODE:=Ptr(Seg0040,$0049);
  { Vorinstallieren mit den normalen Werten }
  if (Byte(MT_VMODE^) = 7) then MT_VSEG := Segb000
  else MT_VSEG := Segb800 ;
  MT_VWIDTH := memw[Seg0040:$004a] ;
  MT_VROWS  := Byte(memw[Seg0040:$0084]+1);
  MT_VOFS   := memw[Seg0040:$004e] ;

  if MTKind=MT_DV then begin
    asm
      mov  ax, MTVersion
      cmp  ah, 2           { Ist major vers. 2 ? }
      jne  @ende           { Wenn nicht (Tame) dann raus }
      mov  ax, $2b01 ;
      mov  cx, $4445 ;  { DE }
      mov  dx, $5351 ;  { SQ }
      int  21h
      mov  ax, $2b02
      mov  bx, $4445  ; { DE }
      mov  dx, $5351  ; { SQ }
      int  21h
      mov  MT_VSEG, dx
      mov  MT_VWIDTH, bl
      mov  MT_VROWS, bh
      mov  MT_VOFS, 0
    @ende:
    end
  end
end ; { dv_video_buffer }

{ ------------------------------------------------------------------------ }
procedure MTStartCritical;assembler;      { Task-Switching aus }
asm
    cmp MTKind,MT_DOS     { DOS, raus }
    je  @ende
    cmp MTKind,MT_OS2     { OS/2, raus, dafr habe ich nichts }
    je  @ende
    cmp MTKind,MT_DV      { DESQview ? }
    jne @WIN
    mov AX,$101B
    INT $15
    jmp @ende
@WIN:
    cmp MTKind,MT_WIN     { Windows ? }
    jne @ende
    mov ax,MTVersion      { Nur ab 3.x }
    cmp ah,3
    jne @ende
    MOV AX,$1681          { MPX-Funktion $1681 }
    INT $2F
    {jmp @ende}
@ende:
end;

{ ------------------------------------------------------------------------ }
procedure MTEndCritical;assembler;        { Task-Switching an }
asm
    cmp MTKind,MT_DOS
    je  @ende
    cmp MTKind,MT_OS2     { OS/2, raus, dafr habe ich nichts }
    je  @ende
    cmp MTKind,MT_DV      { DESQview ? }
    jne @WIN
    mov AX,$101C
    INT $15
    jmp @ende
@WIN:
    cmp MTKind,MT_WIN     { Windows ? }
    jne @ende
    mov ax,MTVersion      { Nur ab 3.x }
    cmp ah,3
    jne @ende
    MOV AX,$1682          { MPX-Funktion $1682 }
    INT $2F
    {jmp @ende}
@ende:
end;

{ ------------------------------------------------------------------------ }
{ ===================== DV Proceduren / Funktionen ======================= }
function DVWinNr: byte ;
begin
  if MTKind=MT_DV then begin
    asm
      mov   ax, $de07
      int   15h
      mov  @RESULT, al
    end ;
  end else begin
    DVWinNr := 0 ;
  end ;
end ;
{ ------------------------------------------------------------------------ }
procedure DVSendMsg( Handle : pointer; _BH, _BL : byte;
                      size : word; var param ); assembler;
asm
 std           { string goes backwards }
 mov dx,sp     { save sp }

 mov cx,size   { load size of param }
 jcxz @SM2     { if zero then don't push anything }

 mov bx,ds     { save ds }

 lds si,param  { load address of param }
 add si,cx     { start from the top }
 dec si        { minus 2 }
 dec si        { ^^^^^^^ }
 shr cx,1      { cx:=cx div 2 }
@SM1:
 lodsw         { load 1 word }
 push ax       { push it }
 loop @SM1      { if cx > 0 loop }

 mov ds,bx     { restore ds }
@SM2:
 les di,Handle { get handle }
 mov ax,es     { move es to ax for compare }
 cmp ax,0      { if segment is 0 then }
 je @SM3       { don't push handle }
 push es       { push segment }
 push di       { push offset }
@SM3:
 mov ah,$12
 mov bh,_bh
 mov bl,_bl
 int $15       { call dv }

 cld           { string goes forward }
 mov ax,sp     { calculate the number of }
 mov cx,dx     { returned parameter(s) }
 sub cx,ax     { in stack }

 jcxz @SMX      { exit if none }
 les di,param  { load address of param }
 add di,size
 shr cx,1      { cx:=cx div 2 }
@SM4:
 pop ax
 stosw
 loop @SM4
@SMX:
end;
{ ------------------------------------------------------------------------ }
function DVTimer_New : pointer;
var
 Handle : pointer;
begin
 { allocate a new timer }
 DVSendMsg( Nil, $01, $0B, $00, Handle );
 DVTimer_New:=Handle;
end;
{ ------------------------------------------------------------------------ }
procedure DVTimer_Start( Handle : pointer; Time : longint );
begin
 { start a timer countdown (TIME is in 1/100 of a second) }
 DVSendMsg(Handle, $0a, $00, sizeof(Time), Time);
end;
{ ------------------------------------------------------------------------ }
function DVTimer_Len( Handle : pointer ) : longint;
var
 Len : longint;
begin
 { get current timer value (in 1/100 of a second) }
 DVSendMsg(Handle, $09, $00, $00, Len);
 DVTimer_Len:=Len;
end;
{ ------------------------------------------------------------------------ }
procedure DVFree( var Handle : pointer );
begin
 { free a handle (close a window/free a timer/etc..) }
 DVSendMsg(Handle, $02, $00, $00, Handle );
 Handle:=Nil;
end;
{ ------------------------------------------------------------------------ }
procedure MTDelay( w : word );
var
 DVTimer : pointer;
 T     : LongInt;
 Stop  : LongInt;
begin
 If MTKind=MT_DV then begin
    DVTimer:=DVTimer_New;
    DVTimer_Start(DVTimer,w);
    repeat
          MTSlice;
    until DVTimer_Len(DVTimer)=0;
    DVFree(DVTimer);
 end
 else begin
      {Crt.Delay(w)}
      TInit(T);
      Stop := T*55+w;
      Repeat
            TInit(T);
            MTSlice;
      until T*55>Stop;
 end;
end;
{ ------------------------------------------------------------------------ }
Function  MTReadKey : Char;     { ReadKey mit TimeSlice }
begin
     If MTLoaded then
     Repeat
           MTSlice;
     until KeyPressed;
     MTReadKey:=ReadKey;
end;
{ ------------------------------------------------------------------------ }
Procedure MT_Install( Kind:Word  );
var h1,h2  : String[10];
begin
     If Kind>MT_Max then MTInit  { Selbst herausfinden }
     else begin
          MTKind:=Kind;
          case MTKind of
           MT_DV  : begin
                    MTVersion:=DV_GetVersion;
                    MTWindow:=DvWinNr;
                    end;
           MT_WIN : CheckWin;
           MT_OS2 : CheckOS2;
           else     CheckOS2;
          end;
     end;
     MTVideoBuffer;
     MTInitVStr;
     Check4Dos;
     If Is4Dos then begin
        Str(Lo(Vers4Dos),h1);
        Str(Hi(Vers4DOS),h2);
        VersStr4DOS:=H1+'.'+H2;
     end;
     MT_WasInited := True;
end;
{ ------------------------------------------------------------------------ }
Procedure DummyProc; far;
begin
end;
{ ------------------------------------------------------------------------ }
function  DosKind : Byte;
VAR Regs: Registers;
begin
  DosKind := 0;
  With Regs do
   BEGIN
    Flags := FCarry;
    ax := $4452;
    Dos.MsDos(Regs);
    If (Flags and FCarry) <> FCarry then
     BEGIN
      If ax=dx then begin
       Case ax of
         $1060 : DosKind := 4;
         $1063 : begin
                 DosKind := 1;
                 MtVersion := $0329; {3.41}
                 end;
         $1064 : begin
                 DosKind := 1;
                 MtVersion := $032A; {3.42}
                 end;
         $1065 : begin
                 DosKind := 1;
                 MtVersion := $0500; {5.00}
                 end;
         $1067 : begin
                 DosKind := 1;
                 MtVersion := $0600; {6.00}
                 end;
         $1070 : begin
                 DosKind := 4;
                 MtVersion := $0000; {0.00}
                 end;
         $1071 : begin
                 DosKind := 1;
                 MtVersion := $0601; {6.01}
                 end;
       end;
       MTInitVStr;
      end
      else If ax=$1072 then begin
           DosKind   := 2;
           MtVersion := $0700;
      end;
   END;
 END;
end;
{ ------------------------------------------------------------------------ }
begin
     MT_IdleProc := DummyProc;
{$EndIf}
end.

