(*
Copyright (C) 1999 Grischa Brockhaus <skullsoft@grischa.de>
modified      1999 Andre Grueneberg <andre@grueneberg.de>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)

Unit Timer;
{ Eine Timer Unit, die den Timerbaustein abfragt }
INTERFACE

{$IfNDef Win32}
Procedure TInit    ( var aTimer : LongInt );
Function  TDiff    ( aTimer : LongInt ): LongInt;
Function  TDiffSec ( aTimer : LongInt ) : LongInt;
Function  TMaxSec  ( aTimer, aMaxSec : LongInt ) : Boolean;
{$EndIf Win32}

IMPLEMENTATION

{$IfDef OS2}
{ Der OS/2 Timer ist nicht gerade genau bei kleinen Werten ! }
Uses Os2Base;
Procedure TInit    ( var aTimer : LongInt );
{ Diese Query scheint genau 1000tel Sekunden auszuspucken ? }
begin
     DosQuerySysInfo(qsv_Ms_Count,qsv_Ms_Count,aTimer,SizeOf(aTimer));
end;
{--------------------------------------------------------------------------}
Function  TDiff    ( aTimer : LongInt ): LongInt;
var Now  : LongInt;
begin
     TInit(Now);
     { Umrechnung der OS/2 Diff in Tics... }
     TDiff := Round(Now / 1000 * 18.2);
end;
{--------------------------------------------------------------------------}
Function  TDiffSec ( aTimer : LongInt ) : LongInt;
var Now  : LongInt;
begin
     TInit(Now);
     TDiffSec := (Now-aTimer) DIV 1000;
end;
{----------------------------------------------------------------------------}
Function TMaxSec( aTimer, aMaxSec : LongInt ) : Boolean;
{ Ist ein Maximum an Sekunden berschritten ? Genauso wie DOS Version }
begin
     TMaxSec:=TDiffSec(aTimer)>aMaxSec;
end;
{--------------------------------------------------------------------------}
{$Else}

var CompiTime :^longint;

{----------------------------------------------------------------------------}
Procedure TInit( var aTimer : LongInt );
{ Speichert den aktuellen UhrWert in aTimer }
begin
     aTimer := CompiTime^;
end;
{----------------------------------------------------------------------------}
Function TDiff ( aTimer : LongInt ): LongInt;
{ bergibt die Differenz seit Initiierung in Tics}
var Now : LongInt;
begin
     TInit( Now );
     If Now<aTimer then begin (* ber Mitternacht *)
        TDiff:=1573040-aTimer+Now;  (* Hchste TicZahl gemessen... *)
     end
     else TDiff:=Now-aTimer;
end;
{----------------------------------------------------------------------------}
Function TDiffSec ( aTimer : LongInt ) : LongInt;
{ bergibt die Differenz seit Initiierung in Sekunden }
var Diff : LongInt;
begin
     TDiffSec:=TDiff(aTimer) DIV 18;
end;
{----------------------------------------------------------------------------}
Function TMaxSec( aTimer, aMaxSec : LongInt ) : Boolean;
{ Ist ein Maximum an Sekunden berschritten ? }
begin
     TMaxSec:=TDiffSec(aTimer)>aMaxSec;
end;
{----------------------------------------------------------------------------}
begin
     CompiTime:=Ptr(Seg0040,$6C);
{$EndIf}
end.
