(*
Copyright (C) 1999 Grischa Brockhaus <skullsoft@grischa.de>
modified      1999 Andre Grueneberg <andre@grueneberg.de>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)

{$Ifdef VirtualPascal}
  {$Smartlink-}
{$Endif}
{$F+,O+}
(*
    TURBO PASCAL LIBRARY 2.0
    STRINGS unit: Extended string-handling routines
*)

UNIT USTRING;


{$IfNDef VirtualPascal}
  {$L SUCASE.OBJ}
  {$L SUPAD.OBJ}
  {$L SUTRIM.OBJ}
  {$L SUTRUNC.OBJ}
  {$L SUCNVRT.OBJ}
  {$L SUMISC.OBJ}
  {$L BM.OBJ}
{$EndIf}


{$V-}

INTERFACE

{$IFdef VirtualPascal}
  Uses Use32;
{$Endif}

TYPE
    FormatConfigRec =   RECORD
                          Fill,               { Symbol for padding }
                          Currency,           { Floating currency sign }
                          Overflow,           { Overflow indicator }
                          FracSep:    CHAR;   { Int/frac seperator }
                        END;


CONST
    UCaseLetters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
    LCaseLetters = 'abcdefghijklmnopqrstuvwxyz';
    Letters      = UCaseLetters+LCaseLetters;
    DecDigits = '0123456789';
    HexDigits = '0123456789ABCDEF';
    OctDigits = '01234567';
    BinDigits = '01';

    { Format symbol record }
    FormatConfig: FormatConfigRec =
            (Fill: '*'; Currency: '$'; Overflow: '?'; FracSep: '-');



FUNCTION LoCase(ch: CHAR): CHAR;
FUNCTION UpperCase(s: STRING): STRING;
FUNCTION LowerCase(s: STRING): STRING;
FUNCTION UpLowerCase(s:String) : String;
FUNCTION DuplChar(ch: CHAR; count: BYTE): STRING;
FUNCTION DuplStr(s: STRING; count: BYTE): STRING;

{ LeerZeichen weghauen }
FUNCTION TrimL(s: STRING): STRING;
FUNCTION TrimR(s: STRING): STRING;

{ Mit LeerZeichen auffllen }
FUNCTION Pad0(s: LongInt; width: BYTE): STRING;  { ZahlenString mit 0 vorne weg }
FUNCTION PadL(s: STRING; width: BYTE): STRING;
FUNCTION PadR(s: STRING; width: BYTE): STRING;

FUNCTION TruncL(s: STRING; width: BYTE): STRING;
FUNCTION TruncR(s: STRING; width: BYTE): STRING;
FUNCTION JustL(s: STRING; width: BYTE): STRING;
FUNCTION JustR(s: STRING; width: BYTE): STRING;
FUNCTION JustC(s: STRING; width: BYTE): STRING;
FUNCTION Precede(s,target: STRING): STRING;
FUNCTION Follow(s,target: STRING): STRING;
FUNCTION Break(VAR s: STRING; d: STRING): STRING;
FUNCTION Span(VAR s: STRING; d: STRING): STRING;
FUNCTION Replace(s,srch,repl: STRING): STRING;     { B.staben mit B.staben }
Procedure ReplaceBuf(var s; srch,repl: String; Size:Word);     { B.staben mit B.staben }
FUNCTION ReplaceStr(s,srch,repl: STRING): STRING;  { String mit String ers. }
FUNCTION Remove(s,srch: STRING): STRING;
FUNCTION RemoveStr(s,srch: STRING): STRING;
Function StripDigits(s:String): String;            { Schmeisst Zahlen aus String }
{$IfNDef VirtualPascal}
FUNCTION StripBit7(s: STRING): STRING;
{$EndIf}
FUNCTION FileSpecDefault(s,path,name,extn: STRING): STRING;
FUNCTION HexStr(n: WORD; count: BYTE): STRING;
FUNCTION OctStr(n: WORD; count: BYTE): STRING;
FUNCTION BinStr(n: WORD; count: BYTE): STRING;
FUNCTION Format(n: REAL; form: STRING): STRING;

{ Suchen in einem Puffer nach Pattern }
function posbm(pat:string; var buf; buflen:word):word;

{ Instr is similar to Pos, but allows to specify a start position at which the
  search in the Target string for the Objct string is to start. }
FUNCTION  Instr (Objct, Target: STRING; StartPos: BYTE): BYTE;

{ Ist Pat in Srch an Stelle Posi ? }
Function IsPos(var pat,srch : String; Posi : Byte):Boolean;
Function LastPos( pat,srch:String ):Byte;

Function XORStr( S: String; c: Char): String;
Function XORStrRand( S: String; C: Char) : String;
{ XORt den String mit festgelegten (RANDSEED) "Zufallszahlen"   }
{ Wird wahrscheinlich bei neuem Compiler andere Werte liefern ! }
{ erstmals benutzt bei BP 7.0 }

Function GetWordOf( S : String; Count : Byte ): String;
{ Holt das Count'e Wort aus S, '' wenn nicht vorhanden }

IMPLEMENTATION

USES DOS;


{$IfNDef VirtualPascal}
FUNCTION LoCase(ch: CHAR): CHAR; EXTERNAL;
FUNCTION UpperCase(s: STRING): STRING; EXTERNAL;
FUNCTION LowerCase(s: STRING): STRING; EXTERNAL;
FUNCTION DuplChar(ch: CHAR; count: BYTE): STRING; EXTERNAL;
{$Else}

FUNCTION LoCase(ch: CHAR): CHAR;
var p    : Integer;
    S    : String[30];
begin
  P:=Pos(ch,UCaseLetters);
  If p>0 then
  begin
    S:=LCaseLetters;
    LoCase:=S[p];
  end else LoCase:=Ch;
end;

FUNCTION UpperCase(s: STRING): STRING;
var I  : Integer;
begin
  for i:=1 to Length(s) do S[i]:=UpCase(S[i]);
  UpperCase := S;
end;

FUNCTION LowerCase(s: STRING): STRING;
var I  : Integer;
begin
  for i:=1 to Length(s) do S[i]:=LoCase(S[i]);
  LowerCase:=S;
end;

FUNCTION DuplChar(ch: CHAR; count: BYTE): STRING;
var UC : String;
begin
  FillChar(UC[1],Count,Ch);
  Uc[0]:=Char(Count);
  DuplChar := UC;
end;
{$EndIf VirtualPascal}

FUNCTION UpLowerCase(s:String) : String;
var h    : String;
    p    : Integer;
begin
  If s='' then Exit;
  s:=LowerCase(s);
  s[1]:=UpCase(s[1]);
  h:='';
  p:= Pos(' ',s);
  While p>0 do
  begin
    h:=h+Copy(s,1,p);
    delete(s,1,p);
    If s<>'' then s[1]:=UpCase(s[1]);
    p:= Pos(' ',s);
  end;
  h:=h+s;
  UpLowerCase:=h;
end;

FUNCTION DuplStr(s: STRING; count: BYTE): STRING;
VAR ds: STRING;
    i:  Integer;
BEGIN
  ds:='';
  FOR i:=1 TO count DO
    ds:=ds+s;
  DuplStr:=ds;
END;

Type TBigChar = Array [1..$FFFF] of Char;
     PBigChar = ^TBigChar;

{$IfNDef VirtualPascal}
FUNCTION TrimL(s: STRING): STRING; EXTERNAL;
FUNCTION TrimR(s: STRING): STRING; EXTERNAL;
FUNCTION PadL(s: STRING; width: BYTE): STRING; EXTERNAL;
FUNCTION PadR(s: STRING; width: BYTE): STRING; EXTERNAL;
FUNCTION TruncL(s: STRING; width: BYTE): STRING; EXTERNAL;
FUNCTION TruncR(s: STRING; width: BYTE): STRING; EXTERNAL;
function posbm(pat:string; var buf; buflen:word):word; EXTERNAL;
{$Else}

FUNCTION TrimL(s: STRING): STRING; Assembler;{$Frame-}
{$Uses edi,esi,ecx}
asm
  cld
  mov  edi, s
  xor  eax, eax
  mov  al, [EDI]
  cmp  al, 0
  ja   @okay
  mov  edi, @Result
  mov  byte ptr [edi],0
  jmp  @ende
@okay:
  inc  edi
  mov  ecx, eax
  mov  al,' '
  cmp  al,[EDI]
  jne  @kopieren
  repe scasb
  dec  edi
  inc  ecx
@kopieren:
  mov  esi, edi
  mov  edi, @Result
  mov  [EDI],cl
  inc  EDI
  rep  movsb
@ende:
end;

FUNCTION TrimR(s: STRING): STRING; Assembler; {$Frame-}
{$Uses edi,esi,ecx}
asm
  cld
  mov  edi, s
  mov  esi, edi
  xor  eax, eax
  mov  al, [edi]
  add  edi, eax
  mov  ecx, eax
  mov  al, ' '
  cmp  [edi], al
  jne   @kein_right
  std
  repe scasb
  inc  ecx
@kein_right:
  cld
  inc  esi
  mov  edi, @Result
  mov  [edi], cl
  inc  edi
  rep  movsb
end;

FUNCTION PadL(s: STRING; width: BYTE): STRING; Assembler; {$Frame-}
{$Uses edi, esi, ecx, edx}
asm
  cld
  mov  esi, s
  mov  edi, @Result
  mov  edx, edi
  inc  edi
  xor  eax, eax
  mov  ecx, eax
  lodsb
  mov  ah, al
  mov  cl, width
  cmp  al, cl
  jae  @kopieren
  sub  cl, al
  add  ah, cl
  mov  al, ' '
  rep  stosb
@kopieren:
  mov  cl, ah
  rep  movsb
  mov  [edx], ah
end;

FUNCTION PadR(s: STRING; width: BYTE): STRING; Assembler; {$Frame-}
{$Uses edi, esi, ecx, edx}
asm
  cld
  mov  esi, s
  mov  edi, @Result
  mov  edx, edi
  inc  edi
  xor  eax, eax
  lodsb
  mov  ecx, eax
  mov  ah, al
  rep  movsb
  mov  cl, width
  cmp  al, cl
  jae  @nix_ran
  sub  cl, al
  add  ah, cl
  mov  al, ' '
  rep  stosb
@nix_ran:
  mov  [edx], ah
end;

FUNCTION TruncL(s: STRING; width: BYTE): STRING; Assembler; {$Frame-}
{$Uses ESI, EDI, ECX }
asm
  cld
  mov  esi, s
  mov  edi, @Result
  xor  eax, eax
  mov  ecx, eax
  lodsb
  mov  cl, width
  cmp  al, cl
  jbe  @no_trunc
  sub  al, cl
  add  esi, eax
  mov  eax, ecx
  jmp  @kopieren
@no_trunc:
  mov  ecx, eax
@kopieren:
  stosb
  rep  movsb
end;

FUNCTION TruncR(s: STRING; width: BYTE): STRING; Assembler; {$Frame-}
{$Uses ESI, EDI, ECX }
asm
  cld
  mov  esi, s
  mov  edi, @Result
  xor  ecx, ecx
  lodsb
  mov  ah, width
  cmp  al, ah
  jbe  @kopieren
  xchg al, ah
@kopieren:
  mov  cl, al
  stosb
  rep  movsb
end;

function posbm(pat:string; var buf; buflen:word):word;
{ Von hinten nach vorne durchscannen }
var SrchPos, SrchOfs : Word;
begin
  SrchPos := 1;
  Repeat
    SrchOfs := 0;
    Repeat
      Inc(SrchOfs);
    until (SrchOfs>Length(pat)) { Gefunden ! }
       or (TBigChar(Buf)[SrchPos+SrchOfs-1]<>Pat[SrchOfs]); { Nicht bereinstimmung }
    If SrchOfs<=Length(pat) then Inc(SrchPos);
  Until (SrchPos = buflen - Length(pat)+1) or (SrchOfs>Length(pat));
  If (SrchOfs>Length(pat)) then PosBM := SrchPos
                           else PosBM := 0;
end;
{$EndIf VirtualPascal}

FUNCTION Pad0(s: LongInt; width: BYTE): STRING;  { ZahlenString mit 0 vorne weg }
var H    : String;
begin
  Str(s,H);
  Pad0:=Replace(PadL(H,width),' ','0');
end;

FUNCTION JustL(s: STRING; width: BYTE): STRING;
BEGIN
  JustL:=PadR(TruncR(TrimL(TrimR(s)),width),width);
END;


FUNCTION JustR(s: STRING; width: BYTE): STRING;
BEGIN
  JustR:=PadL(TruncL(TrimL(TrimR(s)),width),width);
END;


FUNCTION JustC(s: STRING; width: BYTE): STRING;
BEGIN
  s:=TruncR(TrimL(TrimR(s)),width);
  IF LENGTH(s)>=width THEN
    JustC:=s
  ELSE
    JustC:=PadR(CONCAT(DuplChar(#32,(width-LENGTH(s)) DIV 2),s),width);
END;

FUNCTION Precede(s,target: STRING): STRING;
VAR i:  Integer;
BEGIN
  i:=POS(target,s);
  IF i=0 THEN             { Return entire string if target not found }
    Precede:=s
  ELSE
    Precede:=COPY(s,1,i-1);
END;


FUNCTION Follow(s,target: STRING): STRING;
VAR i:  Integer;
BEGIN
  i:=POS(target,s);
  IF i=0 THEN             { Return null string if target not found }
    Follow:=''
  ELSE
    Follow:=COPY(s,i+LENGTH(target),255);
END;


FUNCTION Break(VAR s: STRING; d: STRING): STRING;
VAR i,j:    Integer;
    f:      BOOLEAN;
BEGIN
  i:=0;                                   { Index to input string }
  f:=FALSE;                               { Set when delim. found }
  WHILE (i<LENGTH(s)) AND (NOT(f)) DO     { For each char. in input }
  BEGIN
    INC(i);
    j:=1;                           { Index to delim. string }
    WHILE (j<=LENGTH(d)) AND (NOT(f)) DO { Scan for each delim. }
      IF s[i]=d[j] THEN f:=TRUE
                   ELSE INC(j);
  END;
  IF NOT(f) THEN INC(i);
  Break:=COPY(s,1,i-1);           { Return sub-string up to delimiter }
  s:=COPY(s,i,255);               { and remove from the input string }
END;

FUNCTION Span(VAR s: STRING; d: STRING): STRING;
VAR i,j:    Integer;
    f:      BOOLEAN;
BEGIN
  i:=0;                               { Index to input string }
  f:=FALSE;
  WHILE (i<LENGTH(s)) AND (NOT(f)) DO { For each char. in input }
  BEGIN
    INC(i);
    FOR j:=1 TO LENGTH(d) DO    { Check for specified chars. }
      IF s[i]=d[j] THEN f:=TRUE;
    f:=NOT(f);
  END;
  IF NOT(f) THEN INC(i);
  Span:=COPY(s,1,i-1);                { Return span of specified chrs }
  s:=COPY(s,i,255);                   { and remove from the input }
END;

{ Ersetz alle Strings srchs durch repl im String S }
FUNCTION ReplaceStr(s,srch,repl: STRING): STRING;
var Posi  : Integer;
begin
  ReplaceStr:=S;
  if pos(srch,repl)>0 then exit; { sonst kommt eine uendliche schleife }

  posi:=Pos(srch,s);
  While posi>0 do
  begin
    delete(s,posi,byte(srch[0]));
    insert(repl,s,posi);
    posi:=Pos(srch,s);
  end;
  ReplaceStr:=s;
end;

{ Lsche alle Strings srchs im String S }
FUNCTION RemoveStr(s,srch: STRING): STRING;
var Posi  : Integer;
begin
  posi:=Pos(srch,s);
  While posi>0 do
  begin
    Delete(s,posi,Length(srch));
    posi:=Pos(srch,s);
  end;
  RemoveStr:=s;
end;

FUNCTION Replace(s,srch,repl: STRING): STRING;
VAR i,j:    Integer;
    f:      BOOLEAN;
BEGIN
  IF LENGTH(srch)>LENGTH(repl) THEN       { Ignore search chrs. }
    srch[0]:=CHR(LENGTH(repl));         { without replacements }
  FOR i:=1 TO LENGTH(s) DO                { For each char. in input }
  BEGIN
    j:=1;
    f:=FALSE;                       { Scan all search characters }
    WHILE (j<=LENGTH(srch)) AND (NOT(f)) DO
      IF s[i]=srch[j] THEN
      BEGIN
        s[i]:=repl[j];      { Replace if found }
        f:=TRUE;
      END ELSE
        INC(j);
  END;
  Replace:=s;
END;

Procedure ReplaceBuf(var s; srch,repl: String; Size:Word);     { B.staben mit B.staben }
var  i    : Word;
     last : Word;
begin
  If (srch='') or (repl='') then Exit;
  Last :=0;
  i := PosBM(srch,s,Size);
  While i>0 do
  begin
    Move(repl[1],TBigChar(S)[i+Last],1);
    Inc(Last,i);
    i := PosBM(srch,TBigChar(S)[Last+1],Size-Last);
  end;
end;

FUNCTION Remove(s,srch: STRING): STRING;
Var i,j:    Integer;
BEGIN
  FOR i:=1 TO LENGTH(srch) DO     { For each search character }
    REPEAT
      j:=POS(srch[i],s);      { Repeat search in input string & }
      IF j<>0 THEN            { delete if found until no more }
        DELETE(s,j,1);
    UNTIL j=0;
  Remove:=s;
END;

Function StripDigits(s:String): String;            { Schmeisst Zahlen aus String }
var i    : Integer;
begin
  i:=1;
  While (i>0) and (i<=Length(s)) do
  begin
    If Pos(s[i],DecDigits) > 0 then Delete(s,i,1)
                               else Inc(i);
  end;
  StripDigits:=s;
end;

{$IfNDef VirtualPascal}
FUNCTION StripBit7(s: STRING): STRING; EXTERNAL;
{$EndIf}


FUNCTION FileSpecDefault(s,path,name,extn: STRING): STRING;
VAR d:  DirStr;
    n:  NameStr;
    e:  ExtStr;
BEGIN
  FSplit(s,d,n,e);        { Split file spec. into path, name, & ext. }
  IF LENGTH(d)=0 THEN     { For each field, add default if none }
    d:=path;
  IF LENGTH(n)=0 THEN
    n:=name;
  IF LENGTH(e)=0 THEN
    e:=extn;
  FileSpecDefault:=CONCAT(d,n,e);
END;


{$IfNDef VirtualPascal}
FUNCTION HexStr(n: WORD; count: BYTE): STRING; EXTERNAL;
FUNCTION OctStr(n: WORD; count: BYTE): STRING; EXTERNAL;
FUNCTION BinStr(n: WORD; count: BYTE): STRING; EXTERNAL;
{$Else}
{----------------------------------------------------------------------------}
Function HexStr( n : Word; count: BYTE ) : String;
var Help : String[4];
    unten: Byte;
    i      : Byte;
begin
  Help:='0000';
  for i:=1 to 4 do
  begin
    unten:=n and 15;
    If unten<=9 then Help[5-i]:=Chr(unten+48)
                else Help[5-i]:=chr(unten+87);
    n:=n shr 4;
  end;
  While Help[0]>Char(Count) do Delete(Help,1,1);
  HexStr:=Help;
end;
{----------------------------------------------------------------------------}
FUNCTION OctStr(n: WORD; count: BYTE): STRING;
begin
end;
FUNCTION BinStr(n: WORD; count: BYTE): STRING;
begin
end;
{$EndIf}


FUNCTION Format(n: REAL; form: STRING): STRING;
VAR s1,s2:                  STRING;
    width,dp,sign,i,j:      Byte;
    pad,currency:           CHAR;
    blank,zero,left,paren,
    comma,adjust,reduce:    BOOLEAN;
    {$IfDef VirtualPascal}
    x       :  Longint;
    {$Else}
    x       :  Integer;
    {$EndIf VirtualPascal}


    { Reduce fraction to lowest possible denominator }

  PROCEDURE ReduceFraction(VAR num,denom: BYTE);
  VAR i:  Integer;
  BEGIN
    FOR i:=denom DOWNTO 2 DO
      IF ((num MOD i)=0) AND ((denom MOD i)=0) THEN
      BEGIN
        num:=num DIV i;
        denom:=denom DIV i;
      END;
  END;  { ReduceFraction }


BEGIN  { Format }
  form:=UpperCase(form);
  s1:=Break(form,CONCAT(DecDigits,':'));      { Get leading options }
  IF POS('A',s1)<>0 THEN                      { Absolute value, no sign }
    n:=ABS(n);
  blank:=POS('B',s1)<>0;                      { Blank if zero }
  zero:=POS('Z',s1)<>0;                       { Zero-fill/zero-show }
  left:=POS('L',s1)<>0;                       { Left justify }
  comma:=(POS(',',s1)<>0) OR (POS('C',s1)<>0);    { Commas }
  reduce:=POS('R',s1)=0;                      { No reduction }
  paren:=POS('P',s1)<>0;                      { Negative in parenth. }
  IF POS('+',s1)<>0 THEN                      { Check leading + }
    sign:=1
  ELSE
    sign:=0;
  IF POS('*',s1)<>0 THEN                      { Set fill character }
    pad:='*'
  ELSE
    IF POS('F',s1)<>0 THEN
      pad:=FormatConfig.Fill
    ELSE
      pad:=' ';
  IF POS('$',s1)<>0 THEN                      { Set currency symbol }
    currency:=FormatConfig.Currency
  ELSE
    currency:=#0;
  s1:=Break(form,CONCAT('+- ',#9));           { Get width:decimals }
  IF POS('-',form)<>0 THEN                    { Check trailing +/- sign }
    sign:=3;
  IF POS('+',form)<>0 THEN
    sign:=2;

  s2:=Follow(s1,':');             { s2 is decimals }
  s1:=Precede(s1,':');            { s1 is width }
  VAL(s1,width,x);
  IF x<>0 THEN                    { Default width 12 }
    width:=12;
  IF COPY(s2,1,1)='/' THEN        { Use vulgar fractions }
  BEGIN
    n:=ABS(n);                          { Force absolute value }
    sign:=0;                            { Disable sign display }
    DELETE(s2,1,1);
    VAL(s2,i,x);
    IF (x<>0) OR (i<2) OR (i>99) THEN   { Default resolution 1/2 }
      i:=2;
    j:=ROUND(FRAC(n)/(1.0/i));          { Calculate fraction }
    adjust:=(j=i);                      { Allow for rounding }
    IF adjust THEN j:=0;
    IF reduce THEN                      { Reduce fraction }
      ReduceFraction(j,i);
    STR(j,s1);
    STR(i,s2);
    IF j=0 THEN                         { Format fraction }
      s2:=DuplChar(pad,6)
    ELSE
    BEGIN
      s2:=CONCAT(s1,'/',s2);
      IF (INT(n)=0) AND NOT(zero) THEN
        s2:=CONCAT(pad,s2)
      ELSE
        s2:=CONCAT(FormatConfig.FracSep,s2);
      s2:=CONCAT(s2,DuplChar(pad,6-LENGTH(s2)));
    END;
    IF (INT(n)=0) AND NOT(zero) AND (j<>0) THEN
      s1:=s2
    ELSE
    BEGIN                           { Format integral part }
      IF adjust THEN STR(INT(n)+1:0:0,s1)
                ELSE STR(INT(n):0:0,s1);
      s1:=CONCAT(s1,s2);
    END;
    zero:=FALSE;                        { Disable zero-fill }
  END ELSE
  BEGIN                       { Use decimal fractions }
    VAL(s2,dp,x);               { Get number of decimal places }
    IF x<>0 THEN                { Default to zero decimals }
      dp:=0;
    STR(ABS(n):0:dp,s1);
  END;

  IF comma THEN                   { Insert commas if necessary }
  BEGIN
    s2:=Span(s1,DecDigits);
    i:=(LENGTH(s2)-1) DIV 3;    { i is no. of commas to insert }
    FOR j:=1 TO i DO
      INSERT(',',s2,LENGTH(s2)-(j-1)-(j*3-1));
    s1:=CONCAT(s2,s1);
  END;
  IF currency<>#0 THEN            { Add floating currency symbol }
    s1:=CONCAT(currency,s1);
  IF paren THEN                   { Add signs as required }
  BEGIN
    IF n<0 THEN s1:=CONCAT('(',s1,')')
    ELSE
      IF NOT(left) THEN s1:=CONCAT(s1,' ');
  END ELSE
    CASE sign OF
      0:  IF n<0 THEN                 { Leading - }
            s1:=CONCAT('-',s1);
      1:  IF n<0 THEN                 { Leading + }
            s1:=CONCAT('-', s1)
          ELSE
            s1:=CONCAT('+',s1);
      2:  IF n<0 THEN                 { Trailing + }
            s1:=CONCAT(s1,'-')
          ELSE
            s1:=CONCAT(s1,'+');
      3:  IF n<0 THEN                 { Trailing - }
            s1:=CONCAT(s1,'-')
          ELSE
            IF NOT(left) THEN
              s1:=CONCAT(s1,' ');
    END;
  WITH FormatConfig DO
    IF LENGTH(s1)>width THEN            { Check for field overflow }
      Format:=DuplChar(Overflow,width)
    ELSE
      IF blank AND (LENGTH(Remove(s1,CONCAT('0. ()+-*',Fill,Currency)))=0) THEN
        Format:=DuplChar(#32,width) { Blank if rounded=zero }
      ELSE
        IF zero THEN                { Pad field to width }
        BEGIN
          s2:=Break(s1,DecDigits);
          Format:=CONCAT(s2,DuplChar('0',width-(LENGTH(s2)+LENGTH(s1))),s1);
        END ELSE
        IF left THEN
          Format:=CONCAT(s1,DuplChar(pad,width-LENGTH(s1)))
        ELSE
          Format:=CONCAT(DuplChar(pad,width-LENGTH(s1)),s1);
END;  { Format }

{$IfDef VirtualPascal}
Function XORStr( S: String; C: Char) : String; Assembler;{$Frame-}
{$Uses EDI,ESI}
asm
  cld
  mov   esi,s
  mov   edi,@Result
  xor   eax,eax
  lodsb
  stosb
  mov   ecx,eax
  mov   ah,c
  jecxz @Ende
  @Loop:
  lodsb
  xor   al,ah
  stosb
  Loop  @Loop
  @Ende:
end;
{$Else}
Function XORStr( S: String; C: Char) : String; assembler;
asm
      PUSH  DS                   { DS retten                   }
      CLD                        { Es geht aufwaerts !         }
      XOR   AX, AX               { AX loeschen                 }
      LDS   SI, S                { DS:SI zeigt auf String      }
      LES   DI, @Result          { ES:DI zeigt auf Ergebnis    }
      LODSB                      { Stringlaenge holen und      }
      STOSB                      { wieder speichern            }
      MOV   CX, AX               { und nach CX kopieren        }
      JCXZ  @@Ende               { Wenn NullString -> Ende     }
    @@Loop:
      LODSB                      { Zeichen nach AL holen       }
      XOR   AL, C                { Mit Zeichen XORen           }
      STOSB                      { Zeichen abspeichern         }
      LOOP  @@Loop               { und naechstes               }
    @@Ende:
      POP   DS                   { DS wiederherstellen         }
end;
{$EndIf VirtualPascal}

Function XORStrRand( S: String; C: Char) : String;
{ XORt den String mit festgelegten (RANDSEED) "Zufallszahlen"   }
{ Wird wahrscheinlich bei neuem Compiler andere Werte liefern ! }
{ erstmals benutzt bei BP 7.0 }
var i    : Integer;
begin
  RandSeed := Byte(C);
  for i:=1 to Length(S) do S[i] := Char (Byte(S[i]) XOR (Random(254)+1));
  XORStrRand := S;
end;

FUNCTION  Instr  (Objct, Target: STRING; StartPos: BYTE): BYTE; ASSEMBLER;
{$Ifdef VirtualPascal}
{$Frame-}
ASM
           CLD                   { auto increment for string instructions }
           MOV     EDI, Target   { pointer to target string }
           MOV     ESI, Objct    { pointer to object string }
           XOR     EBX, EBX      { initialize }
           OR      BL, StartPos  {  start position }
           JZ      @NoChange     { don't change when zero }
           DEC     EBX           { dekrement start position }
@NoChange: LODSW                 { AL = length Object, AH = 1. char in Object }
           SUB     AL, 1         { length Object - 1 }
           JB      @NotFound1    { exit, if length-1 < 0 }
           MOV     CL, [EDI]     { length target String }
           MOV     CH, CL        { length traget String }
           SUB     CL, AL        { length target - length Object + 1 }
           JBE     @NotFound1    { if <= 0, exit }
           SUB     CL, BL        { remaining length Target }
           JBE     @NotFound1    { if <= 0, exit }
           INC     EDI           { 1. char in Target }
           ADD     EDI, EBX      { start position in Target }
           XCHG    CH, BH        { BH = length target string, CH = 0 }
           XCHG    AL, AH        { AL = 1. char Object, AH = length Object }
           MOV     EBP, ESI      { save pointer }
@Search1:  REPNZ   SCASB         { scan target for 1st char of Object }
           JNZ     @NotFound2    { if not found, exit }
           MOV     BL, CL        { save remaining length target }
           MOV     CL, AH        { char still to compare in Object }
           MOV     EDX, EDI      { get offset into Target }
           REPZ    CMPSB         { compare CX chars of Target and Object }
           MOV     ESI, EBP      { offset into Object }
           MOV     EDI, EDX      { offset into Target }
           MOV     CL, BL        { remaining length Target }
           JNZ     @Search1      { continue search if no complete match }
           SUB     BH, BL        { pos = length Target - remaining len target}
           SUB     BH, AH        { pos = l. Target - rem. l. target - l. Object}
@NotFound1:MOV     CH, BH        { pos }
@NotFound2:MOV     AL, CH        { pos }
           XOR     AH, AH        { clear MSB }
END; { Instr }
{$Else}
ASM
           CLD                   { auto increment for string instructions }
           PUSH    DS            { save Turbo Pascal's data segment }
           LES     DI, [Target]  { pointer to target string }
           LDS     SI, [Objct]   { pointer to object string }
           XOR     BX, BX        { initialize }
           OR      BL, [StartPos]{  start position }
           JZ      @NoChange     { don't change when zero }
           DEC     BX            { dekrement start position }
@NoChange: LODSW                 { AL = length Object, AH = 1. char in Object }
           SUB     AL, 1         { length Object - 1 }
           JB      @NotFound1    { exit, if length-1 < 0 }
           MOV     CL, ES: [DI]  { length target String }
           MOV     CH, CL        { length traget String }
           SUB     CL, AL        { length target - length Object + 1 }
           JBE     @NotFound1    { if <= 0, exit }
           SUB     CL, BL        { remaining length Target }
           JBE     @NotFound1    { if <= 0, exit }
           INC     DI            { 1. char in Target }
           ADD     DI, BX        { start position in Target }
           XCHG    CH, BH        { BH = length target string, CH = 0 }
           XCHG    AL, AH        { AL = 1. char Object, AH = length Object }
           MOV     BP, SI        { save pointer }
@Search1:  REPNZ   SCASB         { scan target for 1st char of Object }
           JNZ     @NotFound2    { if not found, exit }
           MOV     BL, CL        { save remaining length target }
           MOV     CL, AH        { char still to compare in Object }
           MOV     DX, DI        { get offset into Target }
           REPZ    CMPSB         { compare CX chars of Target and Object }
           MOV     SI, BP        { offset into Object }
           MOV     DI, DX        { offset into Target }
           MOV     CL, BL        { remaining length Target }
           JNZ     @Search1      { continue search if no complete match }
           SUB     BH, BL        { pos = length Target - remaining len target}
           SUB     BH, AH        { pos = l. Target - rem. l. target - l. Object}
@NotFound1:MOV     CH, BH        { pos }
@NotFound2:MOV     AL, CH        { pos }
           XOR     AH, AH        { clear MSB }
           POP     DS            { restore TURBO Pascal's data segment }
END; { Instr }
{$Endif}

Function IsPos(var pat,srch:String;  Posi : Byte):Boolean;
var i    : Integer;
begin
  IsPos:=False;
  If pat[0]>srch[0] then Exit;
  For i:=1 to length(Pat) do
     If Pat[i]<>srch[i] then exit;
  IsPos:=True;
end;

Function LastPos(pat,srch:String):Byte;
var i,j  : Integer;
    Found: Boolean;
begin
  LastPos:=0;
  If (Pat='') or (srch='') or (Srch[0]<Pat[0]) then exit;
  i:=Length(srch)-Length(pat)+1;
  Found:=False;
  While (i>0) and not Found do
  begin
    j:=0;
    Found:=True;
    While (j<Length(Pat)) and Found do
    begin
      Found := Srch[i+j]=Pat[j+1];
      Inc(j);
    end;
    If not Found then Dec(i);
  end;
  LastPos:=i;
end;

Function GetWordOf( S : String; Count : Byte ): String;
{ Holt das Count'e Wort aus S, '' wenn nicht vorhanden }
var H  : String;
    P  : Byte;
    i  : Byte;
begin
  for i:= 1 to Count do
  begin
    S := TrimL(S);
    P := Pos(#32,S);
    If P>0 then
    begin
      H := Copy(S,1,P-1);
      Delete(S,1,P);
    end else
    begin
      H := S;
      S := '';
    end;
  end;
  GetWordOf := H;
end;

END.

