(*
Copyright (C) 1999 Grischa Brockhaus <skullsoft@grischa.de>
modified      1999 Andre Grueneberg <andre@grueneberg.de>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)

{$F+,O+}
unit XBitStr;

INTERFACE


type Str8       = String[8];

Procedure SetBit   ( var B:Byte; Bit:Byte);
Procedure ClearBit ( var B:Byte; Bit:Byte);
Function  IsBit    ( B, Bit:Byte):Boolean;
Procedure ChangeBit( var B:Byte; Bit:Byte);
Function  StrByte  (B:Byte):Str8;
Function  ByteStr  (Stri : String):Byte;
Function  HexStrL  ( T   : LongInt ) : String;
Function  HexStrW  ( T   : Word ) : String;
Function  HexStrB  ( T   : Byte ) : String;
Function  NumStr   ( T   : LongInt ) : String;
Function  StrNum   ( S   : String ) : LongInt;
{$IfNDef VirtualPascal}
function  CUpStr(s: string): string;           { Country-UpStr }
{$EndIf}
function  IsZahlStr( S:String ) : Boolean;     { Besteht der String aus Zahlen ? }
Function  Min(a,b : LongInt) : LongInt;
Function  Max(a,b : LongInt) : LongInt;
Function  ComputeHash(VAR s: STRING): WORD;
IMPLEMENTATION
uses Dos;

{----------------------------------------------------------------------------}
Procedure SetBit( var B:Byte; Bit:Byte);
begin
     B:=B or (1 SHL (Bit-1) );
end;
{----------------------------------------------------------------------------}

Procedure ClearBit( var B:Byte; Bit:Byte);
begin
     B:=B and not (1 SHL (Bit-1) );
end;
{----------------------------------------------------------------------------}

Function IsBit( B, Bit:Byte):Boolean;
begin
     Bit := (1 SHL (Bit-1) );
     IsBit:= B and Bit = Bit;
end;
{----------------------------------------------------------------------------}

Procedure ChangeBit( var B : Byte ; Bit : Byte );
begin
     If IsBit(B,Bit)
     then ClearBit(B,Bit)
     else SetBit(B,Bit);
end;
{----------------------------------------------------------------------------}

Function StrByte(B:Byte):Str8;
var HelpStr : Str8;
    i       : Byte;
begin
     HelpStr:='--------';
     For i:=1 to 8 do
      If IsBit(B,i) Then HelpStr[i]:='X';
     StrByte:=HelpStr;
end;

Function ByteStr(Stri : String):Byte;
var i,b  : Byte;
begin
     b:=0;
     For i:=1 to 8 do
         If UpCase(Stri[i])='X' then SetBit(b,i);
     ByteStr:=b;
end;
{----------------------------------------------------------------------------}

Function HexStrL( T : Longint ) : String;
var Help : String[8];
    unten: Byte;
    i      : Byte;
begin
     Help:='        ';
     for i:=1 to 8 do
     begin
          unten:=t and 15;
          If unten<=9 then Help[9-i]:=Chr(unten+48)
          else Help[9-i]:=chr(unten+87);
          t:=t shr 4;
     end;
     HexStrL:=Help;
end;

{----------------------------------------------------------------------------}
Function HexStrW( T : Word ) : String;
var Help : String[4];
    unten: Byte;
    i      : Byte;
begin
     Help:='    ';
     for i:=1 to 4 do
     begin
          unten:=T and 15;
          If unten<=9 then Help[5-i]:=Chr(unten+48)
          else Help[5-i]:=chr(unten+87);
          t:=t shr 4;
     end;
     HexStrW:=Help;
end;

{----------------------------------------------------------------------------}
Function HexStrB( T : Byte ) : String;
var Help   : String[2];
    unten  : Byte;
    i      : Byte;
begin
     Help:='  ';
     for i:=1 to 2 do
     begin
          unten:=T and 15;
          If unten<=9 then Help[3-i]:=Chr(unten+48)
          else Help[3-i]:=chr(unten+87);
          t:=t shr 4;
     end;
     HexStrB:=Help;
end;
{----------------------------------------------------------------------------}
Function  NumStr   ( T   : LongInt ) : String;
var H : String;
begin
     Str(T,H);
     NumStr:=H;
end;
{----------------------------------------------------------------------------}
Function  StrNum   ( S   : String ) : LongInt;
var
{$IfDef VirtualPascal}
    vc :   LongInt;
{$Else}
    vc :   Integer;
{$EndIf}
    i  : LongInt;
begin
     Val(S,i,vc);
     If vc<>0 then i:=0;
     StrNum:=i;
end;
{----------------------------------------------------------------------------}
{$IfNDef VirtualPascal}
function CUpStr(s: string): string;
{ Country specific string-to-uppercase conversion. Requires DOS unit }
label
     fail;
var
         regs : registers;
         x    : byte;
       begin
         if lo(DosVersion) >= 4 then begin
           with regs do begin
             ax := $6521;
             ds := seg(s);
             dx := ofs(s[1]);
             cx := length(s);
             msdos(regs);
             if odd(flags) then { the attempted conversion failed so }
               goto fail;
           end; { with }
         end { if DOS >= 4.0 } else
       fail:
           for x := 1 to length(s) do
             s[x] := UpCase(s[x]);
         CUpStr := s;
       end; { StrUpper }
{$EndIf VirtualPascal}
{----------------------------------------------------------------------------}
function  IsZahlStr( S:String ) : Boolean;
var
{$IfDef VirtualPascal}
    vc    : LongInt;
{$Else}
    vc    : Integer;
{$EndIf}
    Dummy : Word;
begin
     Val(S,Dummy,vc);
     IsZahlStr:=vc=0;
end;
{----------------------------------------------------------------------------}
Function  Min(a,b : LongInt) : LongInt;
begin
     If a<=b then Min:=a
     else Min:=b;
end;
{----------------------------------------------------------------------------}
Function  Max(a,b : LongInt) : LongInt;
begin
     If a>=b then Max:=a
     else Max:=b;
end;
(*--------------------------------------------------------*)
(*          Hashschlssel-Berechnung fr Strings          *)

FUNCTION ComputeHash(VAR s: STRING): WORD; ASSEMBLER;
(* Hashschlssel (= Summe aller ASCII-Codes im String)    *)
(* berechnen                                              *)
ASM
  MOV    DX, DS  (* Datensegment-Register sichern         *)
  LDS    SI, s   (* DS:SI ==> s                           *)
  CLD            (* Inkrementierender Stringzugriff       *)
  XOR    BX, BX  (* Hashschlssel in BX akkumulieren      *)
  XOR    AX, AX  (* AH darf Berechnung nicht beeinflussen *)
  LODSB          (* Lngenbyte holen ...                  *)
  MOV    CX, AX  (* und als Schleifenzhler speichern     *)
  OR     AX, AX  (* Falls Leerstring, dann schon fertig   *)
  JZ     @Done   (* ... und tsch                        *)
@Next:
  LODSB          (* nchstes Zeichen holen ...            *)
  ADD    BX, AX  (* ASCII-Code zum Hashschlssel addieren *)
  LOOPNZ @Next   (* ... sooft bis alle Zeichen dran waren *)
@Done:
  MOV    DS, DX  (* Datensegment-Register restaurieren    *)
  MOV    AX, BX  (* Funktionswert in AX zurckgeben       *)
END;
{----------------------------------------------------------------------------}
begin
end.
