(*
Copyright (C) 1999 Grischa Brockhaus <skullsoft@grischa.de>
modified      1999 Andre Grueneberg <andre@grueneberg.de>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)

{$F+,O+}
Unit XDaTime;

INTERFACE
uses  Dos;

{ Ein Datum / Zeit in String umwandeln }
Function  PackTime2Date(aDate:LongInt): String; {DD-MM-YY}
Function  PackTime2DateA(aDate:LongInt): String; {MM-DD-YY}
Function  PackTime2DateY(aDate:LongInt): String; {YY-MM-DD}
Function  PackTime2DateLong(aDate:LongInt): String; {DD-MM-YYYY}
Function  PackTime2DateMong(aDate:LongInt): String; {DD-Mmm-YY}
Function  PackTime2Time(aDate:LongInt): String; {HH:MM}
Function  Date2Str(y,m,d : Word): String;      {DD-MM-YY}
Function  Date2StrA(y,m,d : Word): String;     {MM-DD-YY}
Function  Date2MStr(y,m,d:Word):String;         {DD-Mmm-YY}
Function  Date2MStrLong(y,m,d:Word):String;         {DD-Mmm-YYYY}
Function  Time2Str(h,m,s : Word): String;      {HH:MM:SS}
Function  STime2Str(h,m : Word) : String;      {HH:MM}


{ Aktuelle Zeit / Datum holen in String }
Function  DateStr : String;                    {DD-Mmm-YY}
Function  ShortDateStr : String;               {DD-Mmm}
Function  AmiDateStr : String;                 {MM-DD-YY}
Function  GerDateStr : String;                 {TT. Mmmmmm YYYY}
Function  TimeStr : String;                    {HH:MM:SS}
Function  STimeStr : String;                   {HH:MM}
Function  UTCTimeStr : String;                 {YYYYMMDD.HHMMSS}

Function  PackNow : LongInt;  { Jetzige Zeit als FileZeit }

{ Datum zu word packen }
function datetoword(yy,mm,dd : word) : word;
Function PressDateNow : Word;

Function TagesZahl ( DT : DateTime ): LongInt;				{Y2k ok}
{ Ergibt eine absolute TagesZahl, wenn man 2 subtrahiert,
  ergibt das die Tage zwischen den Daten }

Function MinDiff( Alt, Neu : DateTime): LongInt;
{ Differenz der beiden Daten in Minuten }

Function DayOfYear  : word; (* Returns 1 to 365 *)
Function WeekOfYear : Word; (* Returns 1 to 53  *)

Const Monat : Array [0..12] of String[10] =
      ('???','Januar','Februar','Mrz','April','Mai','Juni','Juli',
      'August','September','Oktober','November','Dezember');

      Month : Array [0..12] of String[10] =
      ('???','Januar','Februar','March','April','May','Juni','Juli',
      'August','September','October','November','December');

      SMonth : Array [0..12] of String[3] =
      ('???','Jan','Feb','Mar','Apr','May','Jun','Jul',
      'Aug','Sep','Oct','Nov','Dec');


IMPLEMENTATION
Uses UString;
{----------------------------------------------------------------------------}
Function  PackTime2Date(aDate:LongInt): String; {DD-MM-YY}
var DT : DateTime;
begin
     UnPackTime(aDate,DT);
     PackTime2Date:=Date2Str(DT.Year,DT.Month,DT.Day);
end;
{----------------------------------------------------------------------------}
Function  PackTime2DateLong(aDate:LongInt): String; {DD-MM-YYYY}
var DT : DateTime;
begin
     UnPackTime(aDate,DT);
     PackTime2DateLong:=Pad0(DT.Day,2)+'-'+Pad0(DT.Month,2)+'-'+Pad0(DT.Year,4);
end;
{----------------------------------------------------------------------------}
Function  PackTime2DateMong(aDate:LongInt): String; {DD-Mmm-YY}
var DT : DateTime;
begin
     UnPackTime(aDate,DT);
     PackTime2DateMong:=Pad0(DT.Day,2)+'-'+SMonth[DT.Month]+'-'+TruncL(Pad0(DT.Year,4),2);
end;
{----------------------------------------------------------------------------}
Function  PackTime2DateA(aDate:LongInt): String; {MM-DD-YY}
var DT : DateTime;
begin
     UnPackTime(aDate,DT);
     PackTime2DateA:=Date2StrA(DT.Year,DT.Month,DT.Day);
end;
{----------------------------------------------------------------------------}
Function  PackTime2DateY(aDate:LongInt): String; {YY-MM-DD}
var DT : DateTime;
begin
     UnPackTime(aDate,DT);
     PackTime2DateY:=TruncL(Pad0(DT.Year,4),2)+'-'+Pad0(DT.Month,2)+'-'+Pad0(DT.Day,2);
end;
{----------------------------------------------------------------------------}
Function  PackTime2Time(aDate:LongInt): String; {HH:MM}
var DT : DateTime;
begin
     UnPackTime(aDate,DT);
     PackTime2Time:=STime2Str(DT.Hour,DT.Min);
end;

{----------------------------------------------------------------------------}
Function Date2Str(y,m,d : Word): String;
var HelpStr      : String;
    S,T          : String;
begin
     HelpStr:='';
     Str(D,HelpStr);
     If Length(HelpStr)=1 then HelpStr:='0'+HelpStr;
     Str(M,S);
     If Length(S)=1 then S:='0'+S;
     HelpStr:=HelpStr+'-'+S+'-';
     Str(Y,S);
     T:=s[3]+s[4];
     HelpStr:=HelpStr+T;
     Date2Str:=HelpStr;
end;
{----------------------------------------------------------------------------}
Function  Date2StrA(y,m,d : Word): String;     {MM-DD-YY}
var HelpStr      : String;
    S,T          : String;
begin
     HelpStr:='';
     Str(M,HelpStr);
     If Length(HelpStr)=1 then HelpStr:='0'+HelpStr;
     Str(D,S);
     If Length(S)=1 then S:='0'+S;
     HelpStr:=HelpStr+'-'+S+'-';
     Str(Y,S);
     T:=s[3]+s[4];
     HelpStr:=HelpStr+T;
     Date2StrA:=HelpStr;
end;
{----------------------------------------------------------------------------}
Function Date2MStr(y,m,d:Word):String;         {DD-Mmm-YY}
var HelpStr      : String;
    S,T          : String;
begin
     HelpStr:='';
     Str(D,HelpStr);
     If Length(HelpStr)=1 then HelpStr:='0'+HelpStr;
     HelpStr:=HelpStr+' '+SMonth[M];
     Str(Y,S);
     T:=s[3]+s[4];
     Date2MStr:=HelpStr+' '+T;
end;
{----------------------------------------------------------------------------}
Function  Date2MStrLong(y,m,d:Word):String;         {DD-Mmm-YYYY}
begin
     Date2MStrLong:=Pad0(D,2)+ ' '+SMonth[M]+' '+Pad0(Y,4);
end;
{----------------------------------------------------------------------------}
Function DateStr : String;                     {DD-Mmm-YY}
var HelpStr      : String;
    S,T          : String;
{$IfDef VirtualPascal}
    Y,M,D,W      : LongInt;
{$Else}
    Y,M,D,W      : Word;
{$EndIf}

begin
     HelpStr:='';
     GetDate(Y,M,D,W);
     DateStr:=Date2MStr(Y,M,D);
end;
{----------------------------------------------------------------------------}
Function  ShortDateStr : String;               {DD-Mmm}
var Help : String;
begin
     Help:=DateStr;
     Dec(Help[0],3);
     ShortDateStr:=Help;
end;
{----------------------------------------------------------------------------}
Function AmiDateStr : String;
var
{$IfDef VirtualPascal}
    Y,M,D,W      : LongInt;
{$Else}
    Y,M,D,W      : Word;
{$EndIf}

begin
     GetDate(Y,M,D,W);
     AmiDateStr:=Pad0(M,2)+'-'+Pad0(D,2)+'-'+TruncL(Pad0(Y,4),2);
end;

{----------------------------------------------------------------------------}
Function GerDateStr : String;
var HelpStr      : String;
    S,T          : String;
{$IfDef VirtualPascal}
    Y,M,D,W      : LongInt;
{$Else}
    Y,M,D,W      : Word;
{$EndIf}

begin
     HelpStr:='';
     GetDate(Y,M,D,W);
     Str(D,HelpStr);
     HelpStr:=HelpStr+'. ';
     Case M of
     1:HelpStr:=HelpStr+'Januar';
     2:HelpStr:=HelpStr+'Februar';
     3:HelpStr:=HelpStr+'Mrz';
     4:HelpStr:=HelpStr+'April';
     5:HelpStr:=HelpStr+'Mai';
     6:HelpStr:=HelpStr+'Juni';
     7:HelpStr:=HelpStr+'Juli';
     8:HelpStr:=HelpStr+'August';
     9:HelpStr:=HelpStr+'September';
     10:HelpStr:=HelpStr+'Oktober';
     11:HelpStr:=HelpStr+'November';
     12:HelpStr:=HelpStr+'Dezember';
     end;
     Str(Y,S);
     HelpStr:=HelpStr+' '+S;
     GerDateStr:=HelpStr;
end;

{----------------------------------------------------------------------------}
Function Time2Str(H,M,S : Word) : String;
begin
     Time2Str:=Pad0(H,2)+':'+Pad0(M,2)+':'+Pad0(S,2);
end;
{----------------------------------------------------------------------------}
Function TimeStr : String;
var
{$IfDef VirtualPascal}
    H,M,S,SC     : LongInt;
{$Else}
    H,M,S,SC     : Word;
{$EndIf}

begin
     GetTime(H,M,S,SC);
     TimeStr:=Time2Str(H,M,S);
end;
{----------------------------------------------------------------------------}
Function STime2Str(H,M : Word) : String;
begin
     STime2Str:=Pad0(H,2)+':'+Pad0(M,2);
end;

{----------------------------------------------------------------------------}
Function STimeStr : String;
var
{$IfDef VirtualPascal}
    H,M,S,SC     : LongInt;
{$Else}
    H,M,S,SC     : Word;
{$EndIf}

begin
     GetTime(H,M,S,SC);
     STimeStr:=STime2Str(H,M);
end;
{----------------------------------------------------------------------------}
Function  UTCTimeStr : String;                 {YYYYMMDD.HHMMSS}
var DS, HS  : String;
    S,T          : String;
{$IfDef VirtualPascal}
    Y,M,D,W      : LongInt;
{$Else}
    Y,M,D,W      : Word;
{$EndIf}

begin
     GetDate(Y,M,D,W);
     Str(Y,S);
     DS:=S+Pad0(M,2)+Pad0(D,2);
     HS:= TimeStr;
     Delete(HS,6,1);
     Delete(HS,3,1);
     UTCTimeStr:=DS+'.'+HS;
end;

{----------------------------------------------------------------------------}
Function  PackNow : LongInt;  { Jetzige Zeit als FileZeit }
var
{$IfDef VirtualPascal}
   Year, Month, Day, DayOfWeek,
   Hour, Minute, Second, Sec100 : LongInt;
{$Else}
   Year, Month, Day, DayOfWeek,
   Hour, Minute, Second, Sec100 : Word;
{$EndIf}
   T     : DateTime;
   Time  : Longint;
begin
     GetDate(Year, Month, Day, DayOfWeek);
     GetTime(Hour, Minute, Second, Sec100);
     T.Year  :=Year;
     T.Month :=Month;
     T.Day   :=Day;
     T.Hour  :=Hour;
     T.Min   :=Minute;
     T.Sec   :=Second;
     PackTime(T,Time);
     PackNow:=Time;
end;
{----------------------------------------------------------------------------}
function datetoword(yy,mm,dd : word) : word;
var
   tofield        : word;
   tempbyte       : byte;

begin
   datetoword := 65535;
   tofield := dd - 1;
   tofield := tofield + ((mm - 1) shl 5);
   if (yy < 1980) or (yy > (1980 + 127)) then
      exit;
   yy := yy - 1980;
   tofield := tofield + (yy shl 9);
   datetoword := tofield;
end;
{----------------------------------------------------------------------------}
Function PressDateNow : Word;
{$IfDef VirtualPascal}
var Year, Month, Day, DayOfWeek: LongInt;
{$Else}
var Year, Month, Day, DayOfWeek: Word;
{$EndIf}

begin
     GetDate(Year, Month, Day, DayOfWeek);
     PressDateNow:=datetoword(Year, Month, Day);
end;
{----------------------------------------------------------------------------}
Function TagesZahl ( DT : DateTime ): LongInt;				{Y2k ok}
{ Ergibt eine absolute TagesZahl, wenn man 2 subtrahiert,
  ergibt das die Tage zwischen den Daten }
begin
     IF (DT.Month<3) THEN BEGIN
      DT.Day:=DT.Day+DT.Month;
      IF (DT.Year MOD 4<>0) OR ((DT.Year MOD 100=0) AND (DT.Year MOD 400<>0))
      THEN DT.Day:=DT.Day+1;
     END;
     TagesZahl:= Round (INT(DT.Year*365.25)-ROUND((13-DT.Month)*30.6)+DT.Day-(DT.Year-1600) DIV 100+
     (DT.Year-1600) DIV 400 );
end;

{----------------------------------------------------------------------------}
Function DayOfYear : Word;
var dt1, dt2  : DateTime;
{$IfDef VirtualPascal}
    w         : LongInt;
{$Else}
    w         : Word;
{$Endif}
begin
     Fillchar(dt1,SizeOf(dt1),0);
     GetDate(dt1.year,dt1.month,dt1.day,w);
     Move(dt1,dt2,SizeOf(dt2));
     dt2.day   :=31;
     dt2.Month :=12;
     Dec(dt2.Year);
     DayOfYear := TagesZahl(dt1) - TagesZahl(dt2);
end;
{----------------------------------------------------------------------------}
Function WeekOfYear : Word;
begin
     WeekOfYear := (DayOfYear DIV 7) + 1;
end;
{----------------------------------------------------------------------------}
Function MinDiff( Alt, Neu : DateTime): LongInt;
{ Differenz in Minuten }
var mD      : LongInt;
begin
     If TagesZahl(alt) = TagesZahl(neu) then { Wenn gleiche Tage, dann direkte Differenz }
        MD := (neu.hour * 60 + neu.min) - (alt.hour * 60 + alt.min)
     else begin
        MD := (TagesZahl(neu) - TagesZahl(alt) - 1) * 24 * 60;
        MD := MD + { Falls komplette Tage dazwischen }
              (24*60 - alt.hour * 60 - alt.min) + { File bis Mitternacht }
              (neu.hour * 60 + neu.min) { Mitternacht bis heute }
     end;
     MinDiff := mD;
end;
{----------------------------------------------------------------------------}
begin
end.
