(*
Copyright (C) 1999 Grischa Brockhaus <skullsoft@grischa.de>
modified      1999 Andre Grueneberg <andre@grueneberg.de>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)

{$F+,O+}
Unit XDos;

{$I MAKRO.PAS}

INTERFACE
uses Dos{$ifndef VirtualPascal},LFN{$endif};

Const WildCard: Set of Char = (['*','?']);

const  ScrollLock = $10;
       NumLock    = $20;
       CapsLock   = $40;

       { QuickAndDirty : Boolean = False; }

Var XIOError    : Word;
    Moving      : Boolean ;   { Gibt an, ob gemoved oder kopiert wird }

{$IfNDef VirtualPascal}
var keystat : ^Byte;
{$EndIf}

Function  XIOResult : Word;
Function  IsWildCard ( FName : String ) : Boolean; { FName beinhlt WildCards? }
Function  IsDir      ( DName : String ) : Boolean;
Function  CreateDir( aDir : String ) : Boolean;
Function  CreateDirOfFile( aFile: String ) : Boolean;
Function  FileExists( FName : String ): Boolean;  { Existiert Archive FName ? }
Function  AFileExists( FName : String ): Boolean; { Existiert irgendein FName ? }
Function  FSize( FileName : String ) : Longint;
Function  FDate( FileName : String ) : Longint;

Procedure SetDrive ( C : Char );                   { Drive wechseln     }
Function  GetDrive : Char;                         { Aktuelles Drive    }
function  AllDrives: string;                       { String mit allen Drvs }
Function  IsCDROM ( Drv : Char ):Boolean;

Procedure TouchFile( aFile : String; Datum: LongInt );
Function  SearchSub( StartDir,aName : String ): Boolean;
Procedure Unhide( D:DirStr );
Procedure DelFile( fName : String );
Procedure TruncFile( fName : String );
Procedure CopyFile( FromN, ToN : String);          { COPY FromN ToN     }
Procedure CopyFile21( FromN1,FromN2, ToN : String);{ Copy 2 in 1        }
Procedure CopyFileSeek( FromN, ToN : String ; Von : LongInt);
procedure WildDelete(FileSpec: String);           { FAST DOS-Delete    }

{$IfNDef VirtualPascal}
procedure SetLED  (led:byte; on:boolean);            { Setzt die LEDs     }
Function  IsLED   (Led:Byte): Boolean;               { Ist LED an ?       }
{$EndIf}
Procedure BlinkDrv( D : Char ; An : Boolean );       { Setzt Drv-Lampen AB}

Procedure BSlash ( Var FName:String) ;             { Hngt \ an Dir     }
Procedure UnSlash ( Var FName:String) ;            { Killt \ von Dir    }

Procedure ExpandWC( var aWildCard : String );      { Fllt WC mit ? auf }
Function  MatchWC (pattern,txt:STRING):Boolean;     { Beschr. unten }
Function  GetTempName(FN: String): String;        { Temporrer Name in Verzeichnis FN }

{$IfNDef VirtualPascal}
Function DriveSize(d : byte) : Real; { -1 not found }
Function DriveFree(d : byte) : Real; { -1 not found, }
Function DriveSizeL(d : byte) : LongInt; { -1 not found, -2 : >=MaxLongInt }
Function DriveFreeL(d : byte) : LongInt; { -1 not found, -2 : >=MaxLongInt }
{$ENDIF VirtualPascal}

IMPLEMENTATION

uses
    {$IFDEF BETA}
    Debug,
    {$ENDIF}
    Share,
    Crt,XDaTime,UString, VpFixes;

(*
** DOS file control block
*)

type
  FCB = record
    DriveNum: byte;
    Name: array[1..8] of char;
    Ext: array[1..3] of char;
    BlockNum, RecSize: word;
    FileSize: longint;
    Date, Time: word;
    Reserved: array[1..8] of byte;
    RecInBlock: byte;
    RecNum: longint;
  end;

const DORcmd: array ['A'..'B'] of byte = ($1c, $2d); { Fr BlinkDrv }

{---------------------------------------------------------------------------}
Procedure BlinkDrv( D : Char ; An : Boolean );
begin
  D:=UpCase(D);
  If not (D in (['A','B'])) then exit;
    If An then port [$3f2] := DORcmd [D] else
    port [$3f2] := 0;
end;
{---------------------------------------------------------------------------}
{$IfNDef VirtualPascal}
procedure SetLED(led:byte; on:boolean);
begin
  if on then
    keystat^:=keystat^ or led
  else
    keystat^:=keystat^ and not led;
  if keypressed then;
end;
{$EndIf}
{---------------------------------------------------------------------------}
{$IfNDef VirtualPascal}
Function  IsLED   (Led:Byte): Boolean;               { Ist LED an ?       }
begin
     IsLED:= keystat^ and LED = LED;
end;
{$EndIf}
{---------------------------------------------------------------------------}
Function XIOResult : Word;
begin
     XIOResult:=XIOError;
     XIOError:=0;
end;
{---------------------------------------------------------------------------}
Function  IsWildCard ( FName : String ) : Boolean;
var i     : Byte;
begin
     IsWildCard:=False;
     If FName='' then exit;
     If Pos('*',FName) = 0 then
        If Pos('?',FName) = 0 then Exit;
     IsWildCard:=True;
end;
{---------------------------------------------------------------------------}
Function  IsDir( DName : String ) : Boolean;
var SR    : SearchRec;
    H     : String;
begin
     If DName='\' then begin
        IsDir:=True;
        Exit;
     end;
     (* C:\ *)
     If ( DName[2]=':' ) and
        ( (DName[0]=#2) or ((DName[0]=#3) and (DName[3]='\')) ) then begin
        IsDir:=Pos(UpCase(DName[1]),AllDrives)>0;
        Exit;
     end;
     If DName[Length(DName)]='\' then Dec(DName[0]);
     FindFirst(DName,Directory,SR);
     IsDir:=(DosError=0) and (Directory and SR.Attr=Directory) and (not IsWildCard(DName));
     FindClose(SR);

end;
{---------------------------------------------------------------------------}
Function CreateDirOfFile( aFile: String ) : Boolean;
var D    : DirStr;
    N    : NameStr;
    E    : ExtStr;
begin
     FSplit(aFile,D,N,E);
     CreateDirOfFile:=CreateDir(D);
end;
{---------------------------------------------------------------------------}
Function CreateDir( aDir : String ) : Boolean;
var H    : String;
    Posi : Byte;
    First : Boolean;
begin
     H:='';
     First := True;
     Repeat
           Posi:=Pos('\',aDir);
           If Posi>0 then begin

              If First then begin
                 H:=Copy(aDir,1,Posi-1);
                 First:=False;
              end
              else H:=H+'\'+Copy(aDir,1,Posi-1);

              Delete(aDir,1,Posi);
           end
           else
              If H<>'' then H:=H+'\'+aDir
              else H:=aDir;
           {$I-}MkDir(H);{$I+}
           CreateDir:=IoResult=0;
     until (Posi=0) or (aDir='');
end;
{---------------------------------------------------------------------------}
Procedure BSlash ( Var FName:String) ;
begin
     If FName[Length(FName)]<>'\' then FName:=FName+'\';
end;
{---------------------------------------------------------------------------}
Procedure UnSlash ( Var FName:String) ;
begin
     If FName[Length(FName)]='\' then FName:=Copy(FName,1,Length(FName)-1);
end;
{---------------------------------------------------------------------------}
Function FileExists( FName : String ): Boolean;
var SR : SearchRec;
begin
     FileExists:=False;
     If (FName='') then
        exit;
     FindFirst(FName,Archive,SR);                { Falls Archiv-Bit nicht gesetzt...}
     FileExists:=(DosError=0) and
                  (SR.Attr and (Directory or VolumeID or SysFile)=0);
     FindClose(SR);

end;
{----------------------------------------------------------------------------}
Function  AFileExists( FName : String ): Boolean;   { Existiert FName ? }
var SR : SearchRec;
begin
     AFileExists:=False;
     If (FName='') then
        exit;
     FindFirst(FName,AnyFile,SR);                { Falls Archiv-Bit nicht gesetzt...}
     AFileExists:=(DosError=0) and
                  (SR.Attr and (Directory or VolumeID or SysFile)=0);
     FindClose(SR);
end;
{----------------------------------------------------------------------------}
Function  FSize( FileName : String ) : Longint;
var SR    : SearchRec;
begin
     FSize:=0;
     FindFirst(FileName,Archive,SR);
     If DosError<>0 then begin
        FindClose(SR);
        Exit;
     end;
     FSize:=SR.Size;
     FindClose(SR);
end;
{----------------------------------------------------------------------------}
Function  FDate( FileName : String ) : Longint;
var SR    : SearchRec;
begin
     FDate:=0;
     FindFirst(FileName,Archive,SR);
     If DosError<>0 then begin
        FindClose(SR);
        Exit;
     end;
     FDate:=SR.Time;
     FindClose(SR);
end;
{----------------------------------------------------------------------------}
Procedure TouchFile( aFile : String; Datum: LongInt );
{ Toucht File auf heutiges Datum wenn Datum =0, sonst mit Datum }
var f     : File;
begin
     Assign(f,aFile);
     SetFmode(OnlyWrite);
     {$I-}Reset(f);{$I+}
     If IoResult<>0 then Exit;
     If Datum=0 then SetFTime(f,PackNow)
     else SetFTime(f,Datum);
     Close(f);
end;
{----------------------------------------------------------------------------}
Function  SearchSub( StartDir,aName : String ): Boolean;
var SR    : SearchRec;
begin
     SearchSub:=False;
     FindFirst(StartDir+aName,AnyFile,SR);
     If DosError=0 then begin
        SearchSub:=True;
        FindClose(SR);
        Exit;
     end
     else begin
          FindFirst(StartDir+'*.*',Directory,SR);
          While DosError=0 do begin
                If (SR.Attr and Directory = Directory) then
                   If (SR.Name<>'..') and (SR.Name<>'.') then
                      If SearchSub(StartDir+SR.Name+'\',aName) then begin
                         SearchSub:=True;
                         Exit;
                      end;
                FindNext(SR);
          end;
          FindClose(SR);
     end;
end;
{----------------------------------------------------------------------------}
Procedure Unhide( D:DirStr );
var HideF  : File;
    SR     : SearchRec;
begin

     FindFirst(D+'*.*',AnyFile,SR);
     While DosError=0 do begin
       If (SR.Attr and Directory = Directory) then begin
          If (SR.Name<>'..') and (SR.Name<>'.') then
             UnHide(D+SR.Name+'\');
       end
       else begin
          Assign(HideF,D+SR.NAme);
          SetFAttr(HideF,Archive);
       end;
       FindNext(SR)
     end;
     FindClose(SR);
end;
{---------------------------------------------------------------------------}
Procedure DelFile( fName : String );
var fDel : File;
begin
     {$I-}
     Assign(fDel,fName);
     SetFAttr(fDel,Archive);
     Erase(fDel);
     {$I+}
end;
{---------------------------------------------------------------------------}
Procedure TruncFile( fName : String );
var fDel : File;
begin
     {$I-}
     Assign(fDel,fName);
     SetFAttr(fDel,Archive);
     Reset(fDel,1);
     Truncate(fDel);
     Close(fDel);
     {$I+}
end;
{---------------------------------------------------------------------------}
Procedure CopyFile( FromN, ToN : String);
var FromF, ToF                : File;
{$IfDef VirtualPascal}
    NumRead,NumWritten        : LongInt;
{$Else}
    NumRead,NumWritten        : Word;
{$EndIf}

    buf                       : Pointer;
    buflen                    : Word;
    i     : Byte;
    FD,TD : DirStr;
    FN,TN : NameStr;
    FE,TE : ExtStr;
    SR    : SearchRec;
    Wild  : Boolean;
    Moved : Boolean;
    OrigDate : LongInt;

begin
     If (FromN='') or (ToN='') then
     begin
          XIOError:=2;
          Exit;
     end;

     If FromN=ToN then          { Can't copy in itself.. }
     begin
          XIOError:=1;
          Exit;
     end;

     FromN:=UpperCase(FromN);
     ToN:=UpperCase(ToN);


     FSplit(FromN,FD,FN,FE);
     FSplit(ToN,TD,TN,TE);

     Dec(TD[0],1);
     FindFirst(TD,Directory,SR);   { To-Dir muss da sein }
     If IOResult<>0 then
     begin
          FindClose(SR);
          XIOError:=3;
          Exit;
     end;
     FindClose(SR);
     TD:=TD+'\';


     Wild:=IsWildCard(FromN);
     If Wild then
        If Not(UpperCase(FN+FE)=UpperCase(TN+TE)) then
        begin
          XIOError:=1;
          Exit;
        end;

     FindFirst(FromN,Archive,SR);
     If DosError= 18 then XIOError:=2;
     While DosError=0 do
     begin
         OrigDate:=SR.Time;
         FSplit(SR.Name,TD,FN,FE);
         FSplit(ToN,TD,TN,TE);

         If Wild then begin
            ToN:=TD+FN+FE;
            FromN:=FD+FN+FE;
         end
         else If (TN='') and (TE='') then begin
              TN := FN;
              TE := FE;
              ToN := TD+TN+TE;
         end;


         Assign(FromF,FromN);
         SetFMode(OnlyRead);
         {$I-}Reset(FromF,1);{$I+}
         OldFMode;
         XIOError:=IOResult;
         If XIOResult<> 0 then Exit;
         Close(FromF);

         Assign(ToF,ToN);

         If Moving then begin
            {$I-}Rename(FromF,ToN);{$I+}
            Moved:=IoResult=0
         end;

         If not ( Moving and moved ) then begin
           SetfMode(OnlyRead);
{>}        Reset(FromF,1);
           OldFMode;
           SetfMode(OnlyWrite);
           {$I-}Rewrite(ToF,1);{$I+}   { 1: RecordSize }
           XIOError:=IOResult;
           If XIOError<>0 then begin
              Close(FromF);
              OldFMode;
              Exit;
           end;
           OldFMode;

           { Puffer maximal stellen }

           If MaxAvail>$FFFE then BufLen:=$FFFE
           else BufLen:=MaxAvail;

           GetMem(Buf,BufLen);

           Repeat
               BlockRead(FromF,buf^,BufLen,NumRead);
               BlockWrite(ToF,buf^,NumRead,NumWritten);
           Until (NumRead=0) or (NumWritten<>NumRead);
           Close(FromF);
           Close(ToF);
           SetFMode(OnlyWrite);
           Reset(ToF);
           SetFTime(ToF,OrigDate);
           Close(ToF);
           FreeMem(Buf,BufLen);
         end;
         If Moving and not moved then begin
            {$I-}
            Erase(FromF);
            {$I+}
            XIOError:=IoResult;
         end;
         FindNext(SR);
     end;
     If DosError=18 then DosError:=0;
     FindClose(SR);
end;
{---------------------------------------------------------------------------}
Procedure CopyFile21( FromN1,FromN2, ToN : String);
var FromF1,FromF2, ToF        : File;
{$IfDef VirtualPascal}
    NumRead,NumWritten        : LongInt;
{$Else}
    NumRead,NumWritten        : Word;
{$EndIf}

    buf                       : Array[1..2048] of Char;
    i     : Byte;
    F1D,F2D,TD : DirStr;
    F1N,F2N,TN : NameStr;
    F1E,F2E,TE : ExtStr;
    S     : SearchRec;
    Wild  : Boolean;

begin

     FromN1:=UpperCase(FromN1);
     FromN2:=UpperCase(FromN2);
     ToN:=UpperCase(ToN);


     FSplit(FromN1,F1D,F1N,F1E);
     FSplit(FromN2,F2D,F2N,F2E);
     FSplit(ToN,TD,TN,TE);

     Assign(FromF1,FromN1);
     {$I-}Reset(FromF1,1);{$I+}
     XIOError:=IOResult;
     If XIOResult<> 0 then Exit;

     Assign(FromF2,FromN2);
     {$I-}Reset(FromF2,1);{$I+}
     XIOError:=IOResult;
     If XIOResult<> 0 then Exit;

     Assign(ToF,ToN);
     Rewrite(ToF,1);   { 1: RecordSize }
     Repeat
           BlockRead(FromF1,buf,SizeOf(Buf),NumRead);
           BlockWrite(ToF,buf,NumRead,NumWritten);
     Until (NumRead=0) or (NumWritten<>NumRead);
     Close(FromF1);

     Repeat
           BlockRead(FromF2,buf,SizeOf(Buf),NumRead);
           BlockWrite(ToF,buf,NumRead,NumWritten);
     Until (NumRead=0) or (NumWritten<>NumRead);
     Close(FromF2);

     Close(ToF);
end;
{---------------------------------------------------------------------------}
Procedure CopyFileSeek( FromN, ToN : String ; Von : LongInt);
var FromF, ToF                : File;
{$IfDef VirtualPascal}
    NumRead,NumWritten        : LongInt;
{$Else}
    NumRead,NumWritten        : Word;
{$EndIf}

    buf                       : Array[1..2048] of Char;
    i     : Byte;
    FD,TD : DirStr;
    FN,TN : NameStr;
    FE,TE : ExtStr;
    SR    : SearchRec;
    Wild  : Boolean;

begin
     If (FromN='') or (ToN='') then
     begin
          XIOError:=2;
          Exit;
     end;

     If FromN=ToN then          { Can't copy in itself.. }
     begin
          XIOError:=1;
          Exit;
     end;

     FromN:=UpperCase(FromN);
     ToN:=UpperCase(ToN);


     FSplit(FromN,FD,FN,FE);
     FSplit(ToN,TD,TN,TE);

     Dec(TD[0],1);
     FindFirst(TD,Directory,SR);   { To-Dir muss da sein }
     If IOResult<>0 then
     begin
          FindClose(SR);
          XIOError:=2;
          Exit;
     end;
     FindClose(SR);
     TD:=TD+'\';


     Wild:=IsWildCard(FromN);
     If Wild then
        If Not(UpperCase(FN+FE)=UpperCase(TN+TE)) then
        begin
          XIOError:=1;
          Exit;
        end;

     FindFirst(FromN,Archive,SR);

     While DosError=0 do
     begin

         FSplit(SR.Name,TD,FN,FE);
         FSplit(ToN,TD,TN,TE);

         If Wild then
         begin
            ToN:=TD+FN+FE;
            FromN:=FD+FN+FE;
         end;


         Assign(FromF,FromN);
         {$I-}Reset(FromF,1);{$I+}
         XIOError:=IOResult;
         If XIOResult<> 0 then Exit;

         Seek(FromF,Von);

         Assign(ToF,ToN);
         Rewrite(ToF,1);   { 1: RecordSize }
         Repeat
               BlockRead(FromF,buf,SizeOf(Buf),NumRead);
               BlockWrite(ToF,buf,NumRead,NumWritten);
         Until (NumRead=0) or (NumWritten<>NumRead);
         Close(FromF);
         Close(ToF);
         If Moving then Erase(FromF);
         FindNext(SR);
     end;
     FindClose(SR);
end;
{---------------------------------------------------------------------------}
procedure WildDelete(FileSpec: String);
var
  OldDir, NewDir, DriveDir: DirStr;
  FileName: NameStr;
  FileExt: ExtStr;
  F: FCB;
  TmpFn: String[13];
  aFile    : File;
  SR       : SearchRec;
  {$IFDEF BETA}
  H : String;
  {$ENDIF}
begin

  {$IFDEF BETA}
  WriteDeb('WILDDEL : '+FileSpec);
  {$ENDIF}

  FSplit(FExpand(FileSpec), NewDir, FileName, FileExt);
  TmpFn := FileName + FileExt + #0;
  GetDir(0, OldDir);

  { Falls auf einem anderen Drive gelscht wird, muss das Drive wieder
    in der alten Dir stehen }
  GetDir(Byte(NewDir[1])-Byte('A')+1,DriveDir);

  if NewDir[Length(NewDir)] = '\' then Dec(NewDir[0]);
  {$i-} ChDir(NewDir); {$i+}
  DosError := IOResult;
  {$IFDEF BETA}
  If DosError<>0 then WriteDeb('WILDDEL Error ChDir : '+NewDir);
  {$ENDIF}

  If DosError<>0 then begin
     ChDir(DriveDir);
     ChDir(OldDir);
     Exit;
  end;

     FindFirst(FileName+FileExt,AnyFile{ and not VolumeID},SR);
     While DosError=0 do begin
           If (SR.Attr and Directory= Directory) then
              If (SR.Name<>'.') and (SR.Name<>'..') then begin
                 WildDelete(NewDir+'\'+SR.Name+'\*.*');
                 RmDir(SR.Name)
              end
              else
           else
              If (SR.Attr and VolumeID=0) and (SR.Attr and SysFile=0) then begin
                Assign(aFile,SR.Name);
                SetFAttr(aFile,Archive);
                {$I-}Erase(aFile){$I+};
                If IoResult<>0 then
                {$IFDEF BETA}
                Str(SR.Attr,H);
                WriteDeb('WILDDEL Error erasing : '+SR.Name+' '+H);
                {$ENDIF}
                ;
              end;
           FindNext(SR);
     end;
  {$I-}  ChDir(DriveDir); {$I+}
  {$I-}  ChDir(OldDir); {$I+}
  If IoResult<>0 then Write(#7);
  FindClose(SR);
end;
{---------------------------------------------------------------------------}
procedure SetDrv (d: byte); assembler;
asm
    mov  ah,0Eh
    mov  dl,d
    int  21h
end;
{---------------------------------------------------------------------------}
function GetDrv: byte; assembler;
asm
    mov  ah,19h
    int  21h
end;
{---------------------------------------------------------------------------}
Procedure SetDrive ( C : Char );
begin
     {$IfDef VirtualPascal}
     ChDir(C+':');
     {$Else}
     SetDrv(Byte(UpCase(C))-65)
     {$EndIf}
end;
{---------------------------------------------------------------------------}
Function GetDrive : Char;
{$IfDef VirtualPascal}
var H : String;
begin
     H := FExpand('.');
     GetDrive := H[1];
{$Else}
begin
     GetDrive:=Char(GetDrv+65)
{$EndIf}
end;
{---------------------------------------------------------------------------}
function AllDrives: string;
var i,bak,drv: char;
    s:  string [26];
begin
  bak := GetDrive;
  s := '';
  for i := 'C' to 'Z' do begin
    SetDrive (i);
    if GetDrive = i then s := s + i;
  end;
  SetDrive (bak);
  AllDrives := s
end;
(*--------------------------------------------------------------------------*)
Function  IsCDROM ( Drv : Char ):Boolean;
{$IfDef VirtualPascal}
begin
     IsCDROM := False;
end;
{$Else}
var R  : Registers;
    CDR: string;
    cnt: byte;
begin
   IsCDROM := false;
   CDR      := '';
   with R do
   begin
     AX := $1500;
     BX := $0000;
     CX := $0000;
     Intr( $2F, R );
     If BX > 0 then begin
       for cnt := 0 to (bx-1) do
         CDR := CDR +CHAR( CL + Byte('A') + cnt );
     end;
     IsCDROM := pos( upcase(Drv), CDR ) > 0
   end
end;
{$EndIf}
(*--------------------------------------------------------------------------*)
Procedure ExpandWC( var aWildCard : String );
var N     : NameStr;
    E     : ExtStr;
    D     : DirStr;
    Posi  : Word;
    i     : Word;
begin
     FSplit(aWildCard,D,N,E);

     Posi:=Pos('*',N);
     If Posi>0 then begin
        N[0]:=Char(Posi-1);
        For i:=Length(N)+1 to 8 do N:=N+'?';
     end;

     Posi:=Pos('*',E);
     If Posi>0 then begin
        E[0]:=Char(Posi-1);
        For i:=Length(E)+1 to 8 do E:=E+'?';
     end;

     aWildCard:=D+N+E;
end;
{---------------------------------------------------------------------------}

{ Sucht den Suchstring "pattern" in dem String "txt". }

FUNCTION MatchWC (pattern,txt:STRING):Boolean;
VAR f,i,l1,l2,p,s:Word;
    rest:STRING;
    weg,many:Boolean;
BEGIN
  l1:=Length (pattern);l2:=Length (txt);
  i:=0;p:=0;weg:=False;many:=False;
  WHILE (i<l1) AND (p<l2) AND NOT (weg) DO
  BEGIN
    Inc (i);Inc (p);
    CASE pattern [i] OF
      '?' :many:=False;
      '*' :BEGIN
             s:=i;many:=True;
             Inc (i);
             IF (i<=l1) THEN
             BEGIN
               WHILE (p<=l2) AND (txt [p]<>pattern [i]) DO
               BEGIN
                 Inc (p);
                 IF p>l2 THEN weg:=True;
               END;
             END ELSE p:=l2;
           END;
      ELSE IF UpCase(pattern[i])<>UpCase(txt[p]) THEN
              IF many THEN i:=Pred (s)
              ELSE weg:=True;
    END;
  END;
  IF NOT (weg) THEN
  BEGIN
    IF NOT ((i=Pred (l1)) AND (pattern [l1]='*')) THEN
    IF (i<l1) OR (p<>l2) THEN weg:=True;
  END;
  MatchWC:=NOT (weg);
END;
{---------------------------------------------------------------------------}
{$IFDEF VirtualPascal}
function GetTempName(FN: String): String;
var
  TmpStr,
  tmp : string;
  nr : LongInt;

begin
  If ((Length(FN) > 0) and (FN[Length(FN)] <> '\')) Then
    TmpStr := FN + '\'
  Else
    TmpStr := FN;
  nr := 0;
  repeat
  inc(nr);
  str(nr, tmp);
  until (nr = 1000) or not (afileexists(tmpstr+tmp));
  if nr <> 1000 then GetTempName := tmpstr+tmp else gettempname := '';
end;

{$ELSE}
Function  GetTempName(FN: String): String;
  Var
    TOfs: Word;
    TSeg: Word;
    FH: Word;
    i: Word;
    TmpStr: String;

  Begin
  TSeg := Seg(TmpStr[1]);
  TOfs := Ofs(TmpStr[1]);
  If ((Length(FN) > 0) and (FN[Length(FN)] <> '\')) Then
    TmpStr := FN + '\'
  Else
    TmpStr := FN;
  For i := 1 to 16 Do
   TmpStr[Length(TmpStr) + i] := #0;
  i := 0;
  Asm
    Push ds;
    Mov ah, $5a;
    Mov ch, $00;
    Mov dx, TSeg;
    Mov ds, dx;
    Mov dx, TOfs;
    Mov cl, $00;
    Int $21;              {Create tmp file}
    Mov FH, ax;
    Mov ax, 1;
    jc @JErr
    Mov bx, FH;
    Mov ah, $3e;
    {jmp @J3; this was originally in my code, appears to be an error}
    Int $21;              {Close tmp file}
    @J3:
    Mov ax, 2;
    jc @JErr;
    Mov ah, $41
    Mov dx, TSeg;
    Mov ds, dx;
    Mov dx, TOfs;
    Int $21;              {Erase tmp file}
    Mov ax, 3;
    jc @JErr;
    jmp @JEnd
    @JErr:
    Mov i, ax;
    @JEnd:
    Pop ds;
    End;
  TmpStr[0] := #255;
  TmpStr[0] := Chr(Pos(#0, TmpStr) - 1);
  If i = 0 Then
    GetTempName := TmpStr
  Else
    GetTempName := '';
  End;
{$ENDIF}

{$IfNDef VirtualPascal}

{ Gibt den tatschlichen Wert in Real zurck }
Function DriveSize(d : byte) : Real; { -1 not found }
Var
  R : Registers;
  _ax,
  _cx,
  _dx : Real;
Begin
  With R Do
  Begin
    ah := $36;dl := d;Intr($21, R);
    If AX = $FFFF Then
      DriveSize := -1 { Drive not found }
    Else begin
         _ax := ax;
         _cx := cx;
         _dx := dx;
         DriveSize := _ax * _cx * _dx;
    end;
  End;
End;

{ Gibt den tatschlichen Wert in Real zurck }
Function DriveFree(d : byte) : Real; { -1 not found, }
Var
  R : Registers;
  _ax,
  _cx,
  _bx : Real;
Begin
  With R Do
  Begin
    ah := $36;dl := d;Intr($21, R);
    If AX = $FFFF Then
       DriveFree := -1 { Drive not found }
    Else begin
         _ax := ax;
         _bx := bx;
         _cx := cx;
         DriveFree := _ax * _bx * _cx;
    end;
  End;
End;

{ Konvertierung nach Longint, Ergebnis = 1, wenn Grsse nicht in ein LongInt
  passt. }
Function DriveSizeL(d : byte) : LongInt; { -1 not found, -2 : >=MaxLongInt }
var t  : real;
begin
     t := DriveSize(d);
     If t>=MaxLongInt then DriveSizeL := -2
     else DriveSizeL := Round(t);
end;

{ dito }
Function DriveFreeL(d : byte) : LongInt; { -1 not found, -2 : >=MaxLongInt }
var t  : real;
begin
     t := DriveFree(d);
     If t>=MaxLongInt then DriveFreeL := -2
     else DriveFreeL := Round(t);
end;
{$ENDIF VirtualPascal}

{---------------------------------------------------------------------------}

begin
     XIOError:=0;
     Moving:=False;
{$IfNDef VirtualPascal}
     KeyStat := Ptr(Seg0040,$17);
{$EndIf}
end.
